; This file is part of Magical Fairy Force.

; Magical Fairy Force is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; Magical Fairy Force is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with Magical Fairy Force.  If not, see <http://www.gnu.org/licenses/>.

; Copyright 2020 Average Software.

; Various data objects

    ; This display list is created in code, but is left
    ; here for reference.
;title_screen_display_list
;    .byte       $70,$70,$70 ; 24 blank scanlines.
;    .byte       $42,$00,$20,$02,$02,$07,$02,$02,$02,$02,$02
;    .byte       $02,$02,$02,$02,$02,$02,$02,$02,$02,$02
;    .byte       $02,$02,$02,$02
;    .byte       $41 ; Jump back to start.
;    .word       title_screen_display_list

    ; This display is also created in code, here for reference.
;character_select_display_list
;    .byte       $70,$70,$70 ; 24 blank scanlines.
;    .byte       $ce,$00,$20,$0e ; 78 lines of mode e, at address $2000.
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$8e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$8e
;    .byte       $4e,$00,$08,$0e,$0e,$0e,$0e,$0e ; 36 lines at address $800.
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $8e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$8e
;    .byte       $4e,$00,$30,$0e,$0e,$0e,$0e ; 78 lines of mode e,
;    .byte       $0e,$0e,$0e                 ; at address $3000.
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$8e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $41 ; Jump back to start.
;    .word       character_select_display_list

; Game display list.  Commented out sections
; are generated programmatically.
    org     $b000
game_display_list_header
    .byte       $70,$70,$70 ; 24 blank scanlines.
    .byte       $4e,$00,$10,$8e ; Two lines of mode e, at address $1000.
    .byte       $4e,$00,$0c     ; Ten lines of mode e, at address $c00.
    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
    .byte       $4e,$00,$10,$0e ; Repeat the two-line pattern.
;gdl_p1_scroll_start
;    .byte       $4e,$00,$20     ; Start the scroll area.
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;gdl_p1_scroll_wrap
;    .byte       $ce,$a0,$2a
game_display_list_center
    .byte       $4e,$00,$1b     ; Start the star zone
    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$8e
    .byte       $4e,$00,$0a     ; 10 lines of mode e, at $a00.
    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$8e,$0e
    .byte       $4e,$00,$11,$0e ; 8 lines of mode e at $1100, star zone.
    .byte       $0e,$0e,$0e,$0e,$0e,$8e
;gdl_p0_scroll_start
;    .byte       $4e,$40,$31     ; Start the scroll area.
;    .byte       $4e,$68,$31,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
;    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$8e
game_display_list_bottom
    .byte       $4e,$00,$10,$0e ; Two lines of mode e, at address $1000.
    .byte       $4e,$00,$0e     ; Ten lines of mode e, at address $e00.
    .byte       $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
    .byte       $4e,$00,$10,$0e ; Repeat the two-line pattern.
    .byte       $41,$00,$08     ; Jump back to start.
end_game_display_list

null_display_list
    .byte       $41
    .word       null_display_list

matrix_upper_byte
    .byte       $0b,$10,$15,$1a,$db,$e0,$e5,$ea

matrix_lower_byte
    .byte       $b3,$b8,$bd,$c2,$83,$88,$8d,$92

player_character_counts
    .byte       6,6,6,5,9,5,7,7

player_matrix_data_low
    .byte       <pink_b_matrix_data
    .byte       <frooty_matrix_data
    .byte       <seven_matrix_data
    .byte       <kitty_matrix_data
    .byte       <porkchop_matrix_data
    .byte       <xorex_matrix_data
    .byte       <q_sugar_matrix_data
    .byte       <zevasha_matrix_data

player_matrix_data_high
    .byte       >pink_b_matrix_data
    .byte       >frooty_matrix_data
    .byte       >seven_matrix_data
    .byte       >kitty_matrix_data
    .byte       >porkchop_matrix_data
    .byte       >xorex_matrix_data
    .byte       >q_sugar_matrix_data
    .byte       >zevasha_matrix_data

player_matrix_image_low
    .byte       <pink_b_matrix_image
    .byte       <frooty_matrix_image
    .byte       <seven_matrix_image
    .byte       <kitty_matrix_image
    .byte       <porkchop_matrix_image
    .byte       <xorex_matrix_image
    .byte       <q_sugar_matrix_image
    .byte       <zevasha_matrix_image

player_matrix_image_high
    .byte       >pink_b_matrix_image
    .byte       >frooty_matrix_image
    .byte       >seven_matrix_image
    .byte       >kitty_matrix_image
    .byte       >porkchop_matrix_image
    .byte       >xorex_matrix_image
    .byte       >q_sugar_matrix_image
    .byte       >zevasha_matrix_image

player_letter_data_low
    .byte       <pink_b_letter_data
    .byte       <frooty_letter_data
    .byte       <seven_letter_data
    .byte       <kitty_letter_data
    .byte       <porkchop_letter_data
    .byte       <xorex_letter_data
    .byte       <q_sugar_letter_data
    .byte       <zevasha_letter_data

player_letter_data_high
    .byte       >pink_b_letter_data
    .byte       >frooty_letter_data
    .byte       >seven_letter_data
    .byte       >kitty_letter_data
    .byte       >porkchop_letter_data
    .byte       >xorex_letter_data
    .byte       >q_sugar_letter_data
    .byte       >zevasha_letter_data

player_portrait_data_low
    .byte       <pink_b_portrait
    .byte       <frooty_portrait
    .byte       <seven_portrait
    .byte       <kitty_portrait
    .byte       <porkchop_portrait
    .byte       <xorex_portrait
    .byte       <q_sugar_portrait
    .byte       <zevasha_portrait

player_portrait_data_high
    .byte       >pink_b_portrait
    .byte       >frooty_portrait
    .byte       >seven_portrait
    .byte       >kitty_portrait
    .byte       >porkchop_portrait
    .byte       >xorex_portrait
    .byte       >q_sugar_portrait
    .byte       >zevasha_portrait

portrait_color_low
    .byte       <pink_b_portrait_table
    .byte       <frooty_portrait_table
    .byte       <seven_portrait_table
    .byte       <kitty_portrait_table
    .byte       <porkchop_portrait_table
    .byte       <xorex_portrait_table
    .byte       <q_sugar_portrait_table
    .byte       <zevasha_portrait_table

portrait_color_high
    .byte       >pink_b_portrait_table
    .byte       >frooty_portrait_table
    .byte       >seven_portrait_table
    .byte       >kitty_portrait_table
    .byte       >porkchop_portrait_table
    .byte       >xorex_portrait_table
    .byte       >q_sugar_portrait_table
    .byte       >zevasha_portrait_table

cpu_routine_low
    .byte       <pink_b_cpu
    .byte       <frooty_cpu
    .byte       <seven_cpu
    .byte       <kitty_cpu
    .byte       <porkchop_cpu
    .byte       <xorex_cpu
    .byte       <q_sugar_cpu
    .byte       <zevasha_cpu

cpu_routine_high
    .byte       >pink_b_cpu
    .byte       >frooty_cpu
    .byte       >seven_cpu
    .byte       >kitty_cpu
    .byte       >porkchop_cpu
    .byte       >xorex_cpu
    .byte       >q_sugar_cpu
    .byte       >zevasha_cpu

schedule_pm_adjustment
    .byte       32,52,72,92

big_letter_7
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $aa,$be
    .byte       $00,$3e
    .byte       $00,$f8
    .byte       $00,$f8
    .byte       $03,$e0
    .byte       $03,$e0
    .byte       $03,$e0
    .byte       $03,$e0
    .byte       $03,$e0
    .byte       $03,$e0
    .byte       $03,$e0
    .byte       $03,$e0
    .byte       $03,$e0
    .byte       $02,$a0

big_letter_a
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $fa,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $fa,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $a8,$2a

big_letter_b
    .byte       $ff,$f8
    .byte       $ff,$fe
    .byte       $fa,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $ff,$f8
    .byte       $ff,$f8
    .byte       $fa,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $ff,$fe
    .byte       $ff,$f8
    .byte       $aa,$a8

big_letter_c
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $fa,$aa
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $aa,$aa

big_letter_e
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $fa,$aa
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $ff,$e0
    .byte       $ff,$e0
    .byte       $fa,$a0
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $aa,$aa

big_letter_f
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $fa,$aa
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $ff,$e0
    .byte       $ff,$e0
    .byte       $fa,$a0
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $a8,$00

big_letter_g
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $fa,$be
    .byte       $f8,$2a
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$fe
    .byte       $f8,$fe
    .byte       $f8,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $aa,$aa

big_letter_h
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $fa,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $a8,$2a

big_letter_i
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $af,$ea
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $aa,$aa

big_letter_k
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$f8
    .byte       $fb,$e0
    .byte       $ff,$e0
    .byte       $fe,$f8
    .byte       $f8,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $a8,$2a

big_letter_n
    .byte       $f8,$3e
    .byte       $fe,$3e
    .byte       $ff,$be
    .byte       $ff,$be
    .byte       $ff,$be
    .byte       $ff,$be
    .byte       $ff,$be
    .byte       $ff,$fe
    .byte       $fb,$fe
    .byte       $fb,$fe
    .byte       $fb,$fe
    .byte       $fb,$fe
    .byte       $fb,$fe
    .byte       $fa,$fe
    .byte       $f8,$be
    .byte       $a8,$2a

big_letter_o
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $fa,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $aa,$aa
    
big_letter_p
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $fa,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $fa,$aa
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $a8,$00

big_letter_q
    .byte       $3f,$f8
    .byte       $ff,$fe
    .byte       $fa,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $fb,$be
    .byte       $fb,$fe
    .byte       $ff,$f8
    .byte       $be,$fe
    .byte       $28,$aa

big_letter_r
    .byte       $ff,$f8
    .byte       $ff,$f8
    .byte       $fa,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $ff,$f8
    .byte       $ff,$f8
    .byte       $fb,$e0
    .byte       $fa,$f8
    .byte       $f8,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $a8,$2a

big_letter_s
    .byte       $3f,$fe
    .byte       $ff,$fe
    .byte       $fa,$aa
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $f8,$00
    .byte       $be,$00
    .byte       $2f,$80
    .byte       $0b,$e0
    .byte       $02,$f8
    .byte       $00,$be
    .byte       $00,$3e
    .byte       $00,$3e
    .byte       $ff,$fe
    .byte       $ff,$f8
    .byte       $aa,$a8

big_letter_t
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $af,$ea
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0a,$a0

big_letter_u
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $aa,$aa

big_letter_v
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $be,$f8
    .byte       $3e,$f8
    .byte       $3e,$f8
    .byte       $3e,$f8
    .byte       $3e,$f8
    .byte       $2f,$e0
    .byte       $0f,$e0
    .byte       $0a,$a0

big_letter_x
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $3e,$f8
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $3e,$f8
    .byte       $f8,$be
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $a8,$2a

big_letter_y
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $f8,$3e
    .byte       $3e,$f8
    .byte       $3e,$f8
    .byte       $3e,$f8
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0f,$e0
    .byte       $0a,$a0

big_letter_z
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $aa,$be
    .byte       $00,$3e
    .byte       $00,$f8
    .byte       $00,$f8
    .byte       $03,$e0
    .byte       $03,$e0
    .byte       $0f,$80
    .byte       $0f,$80
    .byte       $3e,$00
    .byte       $3e,$00
    .byte       $f8,$00
    .byte       $ff,$fe
    .byte       $ff,$fe
    .byte       $aa,$aa

; This overlaps with the period data.
big_letter_hyphen
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $fe
    .byte       $fe
    .byte       $fe
    .byte       $aa

big_letter_period
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $00
    .byte       $3e
    .byte       $3e
    .byte       $3e
    .byte       $3e
    .byte       $2a

big_letter_7_width      equ 2
big_letter_a_width      equ 2
big_letter_b_width      equ 2
big_letter_c_width      equ 2
big_letter_e_width      equ 2
big_letter_f_width      equ 2
big_letter_g_width      equ 2
big_letter_h_width      equ 2
big_letter_i_width      equ 2
big_letter_k_width      equ 2
big_letter_n_width      equ 2
big_letter_o_width      equ 2
big_letter_p_width      equ 2
big_letter_q_width      equ 2
big_letter_r_width      equ 2
big_letter_s_width      equ 2
big_letter_t_width      equ 2
big_letter_u_width      equ 2
big_letter_v_width      equ 2
big_letter_x_width      equ 2
big_letter_y_width      equ 2
big_letter_z_width      equ 2
big_letter_period_width equ 1
big_letter_hyphen_width equ 1

game_portrait_offset
    .byte       pink_b_game_row_offset
    .byte       frooty_game_row_offset
    .byte       seven_game_row_offset
    .byte       kitty_game_row_offset
    .byte       porkchop_game_row_offset
    .byte       xorex_game_row_offset
    .byte       q_sugar_game_row_offset
    .byte       zevasha_game_row_offset

game_portrait_color_offset
    .byte       pink_b_game_portrait_offset
    .byte       frooty_game_portrait_offset
    .byte       seven_game_portrait_offset
    .byte       kitty_game_portrait_offset
    .byte       porkchop_game_portrait_offset
    .byte       xorex_game_portrait_offset
    .byte       q_sugar_game_portrait_offset
    .byte       zevasha_game_portrait_offset

player_sprite_p1_colors
    .byte       $00,$f8,$0f,$00,$00,$48,$80,$d2

player_sprite_p2_colors
    .byte       $48,$68,$82,$48,$f8,$f8,$56,$68

player_sprite_p3_colors
    .byte       $12,$c6,$04,$00,$1c,$8e,$9c,$60

sprite_base_low
    .byte       <pink_b_p1_sprite
    .byte       <frooty_p1_sprite
    .byte       <seven_p1_sprite
    .byte       <kitty_p1_sprite
    .byte       <porkchop_p1_sprite
    .byte       <xorex_p1_sprite
    .byte       <q_sugar_p1_sprite
    .byte       <zevasha_p1_sprite

sprite_base_high
    .byte       >pink_b_p1_sprite
    .byte       >frooty_p1_sprite
    .byte       >seven_p1_sprite
    .byte       >kitty_p1_sprite
    .byte       >porkchop_p1_sprite
    .byte       >xorex_p1_sprite
    .byte       >q_sugar_p1_sprite
    .byte       >zevasha_p1_sprite

start_attack_vectors_low
    .byte       <pink_b_start_attack
    .byte       <frooty_start_attack
    .byte       <seven_start_attack
    .byte       <kitty_start_attack
    .byte       <porkchop_start_attack
    .byte       <xorex_start_attack
    .byte       <q_sugar_start_attack
    .byte       <zevasha_start_attack

start_attack_vectors_high
    .byte       >pink_b_start_attack
    .byte       >frooty_start_attack
    .byte       >seven_start_attack
    .byte       >kitty_start_attack
    .byte       >porkchop_start_attack
    .byte       >xorex_start_attack
    .byte       >q_sugar_start_attack
    .byte       >zevasha_start_attack

process_attack_vectors_low
    .byte       <pink_b_process_attack
    .byte       <frooty_process_attack
    .byte       <seven_process_attack
    .byte       <kitty_process_attack
    .byte       <porkchop_process_attack
    .byte       <xorex_process_attack
    .byte       <q_sugar_process_attack
    .byte       <zevasha_process_attack

process_attack_vectors_high
    .byte       >pink_b_process_attack
    .byte       >frooty_process_attack
    .byte       >seven_process_attack
    .byte       >kitty_process_attack
    .byte       >porkchop_process_attack
    .byte       >xorex_process_attack
    .byte       >q_sugar_process_attack
    .byte       >zevasha_process_attack

matrix_images_low
    .byte       <pink_b_matrix_background
    .byte       <frooty_matrix_background
    .byte       <seven_matrix_background
    .byte       <kitty_matrix_background
    .byte       <porkchop_matrix_background
    .byte       <xorex_matrix_background
    .byte       <q_sugar_matrix_background
    .byte       <zevasha_matrix_background

matrix_images_high
    .byte       >pink_b_matrix_background
    .byte       >frooty_matrix_background
    .byte       >seven_matrix_background
    .byte       >kitty_matrix_background
    .byte       >porkchop_matrix_background
    .byte       >xorex_matrix_background
    .byte       >q_sugar_matrix_background
    .byte       >zevasha_matrix_background

ending_data_low
    .byte       <pink_b_ending_data
    .byte       <frooty_ending_data
    .byte       <seven_ending_data
    .byte       <kitty_ending_data
    .byte       <porkchop_ending_data
    .byte       <xorex_ending_data
    .byte       <q_sugar_ending_data
    .byte       <zevasha_ending_data

ending_data_high
    .byte       >pink_b_ending_data
    .byte       >frooty_ending_data
    .byte       >seven_ending_data
    .byte       >kitty_ending_data
    .byte       >porkchop_ending_data
    .byte       >xorex_ending_data
    .byte       >q_sugar_ending_data
    .byte       >zevasha_ending_data

cloud_rate_table
    .byte       120,100,80,60,40,30,20,10

scroll_rate_table
    .byte       8,7,6,5,4,3,2,1

star_hspeed_table_1
    .byte       $00,$04,$09,$0c,$10

star_hspeed_table_2
    .byte       $00,$06,$0b,$0e,$12

star_hspeed_table_3
    .byte       $00,$08,$0d,$10,$14

star_hspeed_table_4
    .byte       $00,$0a,$0f,$12,$16

star_hspeed_table_low
    .byte       <star_hspeed_table_1
    .byte       <star_hspeed_table_2
    .byte       <star_hspeed_table_3
    .byte       <star_hspeed_table_4

star_hspeed_table_high
    .byte       >star_hspeed_table_1
    .byte       >star_hspeed_table_2
    .byte       >star_hspeed_table_3
    .byte       >star_hspeed_table_4

cpu_hspeed_table
    .byte       1,1,2,2,3,3,4,4

cpu_vspeed_table
    .byte       1,1,1,2,2,2,3,3

cpu_attack_odds_table
    .byte       1,1,2,2,2,3,3,4

; These four objects have some signifcant overlap
; in order to save cartridge space.
wing_sprite_1
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %01100110
    .byte       %11111111
    .byte       %01111110
    .byte       %00000000
    .byte       %00011000
    .byte       %00111100
    .byte       %11000011
    .byte       %00000000
    .byte       %00000000

wing_sprite_2
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %11000011
    .byte       %01100110
    .byte       %01111110
    .byte       %00111100
    .byte       %00000000
    .byte       %00111100
    .byte       %11111111

gauge_table_p1
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000

gauge_table_p0
    .byte       %00000000
    .byte       %10000000
    .byte       %11000000
    .byte       %11100000
    .byte       %11110000
    .byte       %11111000
    .byte       %11111100
    .byte       %11111110
    .byte       %11111111
    .byte       %11111111
    .byte       %11111111
    .byte       %11111111
    .byte       %11111111
    .byte       %11111111
    .byte       %11111111
    .byte       %11111111
    .byte       %11111111

star_sprite
    .byte       %10000010
    .byte       %00000000
    .byte       %00101000
    .byte       %10000000
    .byte       %00000010
    .byte       %00101000
    .byte       %00000000
    .byte       %10000010

cloud_sprite
    .byte       %00000001,%01000000
    .byte       %00010101,%01010101
    .byte       %01010101,%01010101
    .byte       %00010101,%01010100
    .byte       %01010100,%00000101
    .byte       %00010001,%01010101
    .byte       %01010101,%01010101
    .byte       %00010101,%00010100

fairy_dust_sprite
    .byte       %00001100,%00110000
    .byte       %11000011,%00001100
    .byte       %00110000,%11000011
    .byte       %11000011,%00001100
    .byte       %00110000,%11000000
    .byte       %00001100,%00000011
    .byte       %11000000,%11001100
    .byte       %00110011,%00000000

lightning_sprite
    .byte       %00000000,%10000000
    .byte       %00000010,%10000000
    .byte       %00001010,%10000000
    .byte       %00101010,%10101010
    .byte       %10101010,%10101000
    .byte       %00000010,%10100000
    .byte       %00000010,%10000000
    .byte       %00000010,%00000000

versus_sprites
    .byte       %10000011   ; Missiles.
    .byte       %10000011
    .byte       %10000011
    .byte       %10000011
    .byte       %10000011
    .byte       %10000011
    .byte       %10000011
    .byte       %10000011
    .byte       %10000011
    .byte       %10000011
    .byte       %10000011
    .byte       %11000011
    .byte       %11001111
    .byte       %11001111
    .byte       %11001111
    .byte       %00001111
    .byte       %11110000
    .byte       %00001111
    .byte       %00001111
    .byte       %11110000

    .byte       %00000110   ; Player 0.
    .byte       %00000110
    .byte       %00001110
    .byte       %00001100
    .byte       %00011100
    .byte       %00011011
    .byte       %00111011
    .byte       %00110011
    .byte       %01110011
    .byte       %01100011
    .byte       %11100011
    .byte       %11000011
    .byte       %11000011
    .byte       %10000000
    .byte       %10000000
    .byte       %00000000
    .byte       %00000000
    .byte       %11111111
    .byte       %11111111
    .byte       %00000000

    .byte       %00000000   ; Player 1.
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %11111110
    .byte       %11111110
    .byte       %10000000
    .byte       %10000000
    .byte       %10000000
    .byte       %10000000
    .byte       %11111110
    .byte       %11111110
    .byte       %00000110
    .byte       %00000110
    .byte       %00000110
    .byte       %00000110
    .byte       %11111110
    .byte       %11111110
    .byte       %00000000

    .byte       %00000011   ; Player 2.
    .byte       %00000111
    .byte       %00000111
    .byte       %00001110
    .byte       %00001110
    .byte       %00011100
    .byte       %00011100
    .byte       %00111000
    .byte       %00111000
    .byte       %01110000
    .byte       %01110000
    .byte       %11100000
    .byte       %11100000
    .byte       %11000011
    .byte       %11000000
    .byte       %10000000
    .byte       %10000000
    .byte       %00000000
    .byte       %00000000
    .byte       %11111111

    .byte       %00000000   ; Player 3.
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000001
    .byte       %00000001
    .byte       %01111111
    .byte       %00000000
    .byte       %00000000
    .byte       %00000000
    .byte       %00000001
    .byte       %00000001
    .byte       %11111001
    .byte       %00000001
    .byte       %00000001
    .byte       %00000001
    .byte       %00000001
    .byte       %00000001
    .byte       %11111111

; Sound resources.
; Format is: AUDC value, then a 0 terminated sequence
; of AUDF value + duration in frames pairs.
; Special frequency values:
; ff: Rest period, play nothing.
; fe: AUDC change, byte that follows is the new AUDC.
; Special timing values:
; ff: Continuous sound. No 0 terminator in this case.

select_move_sound
    .byte       $e3
    .byte       $01,$01
    .byte       $02,$01
    .byte       $03,$01
    .byte       $0

select_confirm_sound
    .byte       $e3
    .byte       $30,$05
    .byte       $20,$05
    .byte       $10,$05
    .byte       $30,$05
    .byte       $20,$05
    .byte       $10,$05
    .byte       $0

player_damage_sound
    .byte       $e3
    .byte       $10,$05
    .byte       $08,$05
    .byte       $10,$05
    .byte       $08,$05
    .byte       $0

player_death_sound
    .byte       $e3
    .byte       $80,$08
    .byte       $90,$08
    .byte       $a0,$08
    .byte       $b0,$08
    .byte       $c0,$08
    .byte       $d0,$08
    .byte       $e0,$08
    .byte       $f0,$08
    .byte       $0

player_shot_sound
    .byte       $e3
    .byte       $ff,$01
    .byte       $0

fairy_dust_sound
    .byte       $e3
    .byte       $1b,$3
    .byte       $1c,$3
    .byte       $19,$3
    .byte       $1b,$3
    .byte       $18,$3
    .byte       $1b,$3
    .byte       $16,$3
    .byte       $1b,$3
    .byte       $13,$3
    .byte       $14,$3
    .byte       $12,$3
    .byte       $13,$3
    .byte       $0

lightning_sound
    .byte       $03
    .byte       $10,$a
    .byte       $16,$a
    .byte       $1b,$a
    .byte       $0

lightning_hit
    .byte       $c8
    .byte       $50,$a
    .byte       $48,$a
    .byte       $0

cloud_sound
    .byte       $01
    .byte       $02,$1
    .byte       $0

fuel_out_sound
    .byte       $e3
    .byte       $10,$a
    .byte       $18,$a
    .byte       $20,$a
    .byte       $28,$a
    .byte       $30,$a
    .byte       $38,$7
    .byte       $0

star_shoot_sound
    .byte       $e1
    .byte       $10,$2
    .byte       $20,$2
    .byte       $10,$2
    .byte       $0

star_hit_sound
    .byte       $e1
    .byte       $1,$2
    .byte       $2,$2
    .byte       $3,$2
    .byte       $0

cloud_hit_sound
    .byte       $01
    .byte       $02,$2
    .byte       $10,$2
    .byte       $0

; Text resources.
gpl_text
    .byte   "Magical Fairy Force is free software:",$0
    .byte   "you can redistribute it and/or modify it",$0
    .byte   "under the terms of the GNU General",$0
    .byte   "Public License as published by the Free",$0
    .byte   "Software Foundation, either version 3 of",$0
    .byte   "the License, or (at your option) any",$0
    .byte   "later version.",$0
    .byte   $0
    .byte   "Magical Fairy Force is distributed in",$0
    .byte   "the hope that it will be useful, but",$0
    .byte   "WITHOUT ANY WARRANTY; without even the",$0
    .byte   "implied warranty of MERCHANTABILITY or",$0
    .byte   "FITNESS FOR A PARTICULAR PURPOSE.  See",$0
    .byte   "the GNU General Public License for more",$0
    .byte   "details.",$0
    .byte   $0
    .byte   "You should have received a copy of the",$0
    .byte   "GNU General Public License along with",$0
    .byte   "Magical Fairy Force.  If not, see",$0
    .byte   "<http://www.gnu.org/licenses/>.",$0
    .byte   $0
    .byte   " Press # to return to the title screen",$0

pink_b_ending_data
    .byte   4           ; Line count.
    .byte   "Justice is served, but Pink has found",$0
    .byte   "evidence of contact between Zevasha and",$0
    .byte   "Dominic, Pink's nemesis on Earth.",$0
    .byte   "What evil could they be planning?",$0

frooty_ending_data
    .byte   6               ; Line count.
    .byte   "Entrusted by her queen with the defense",$0
    .byte   "of Fairy Land, Frooty succeeds in her",$0
    .byte   "duty and thwarts Zevasha's plans.",$0
    .byte   "Forming a partnership with the robot",$0
    .byte   "soldier 7ZC-BX, Frooty ensures peace",$0
    .byte   "for many years to come.",$0

seven_ending_data
    .byte   6               ; Line count.
    .byte   "7ZC-BX's performance demonstrated the",$0
    .byte   "potential of the robot soldier program.",$0
    .byte   "Scheduled for scrapping in favor of",$0
    .byte   "a more advanced model, the misfit",$0
    .byte   "prototype was saved from destruction",$0
    .byte   "when Frooty adopted her",$0
    
kitty_ending_data
    .byte   6               ; Line count.            ; <- 40 columns.
    .byte   "Having turned on Zevasha, nothing is",$0
    .byte   "left to restrain the brutal power of",$0
    .byte   "Kitty. The news of Zevasha's downfall",$0
    .byte   "brings scant comfort to the citizens of",$0
    .byte   "Fairy Land. They know that Kitty is out",$0
    .byte   "there... waiting... and hungry.",$0

porkchop_ending_data
    .byte   6               ; Line count.
    .byte   "As the new hero of Fairy Land, Pork-Chop",$0
    .byte   "receives medals, a parade in his honor,",$0
    .byte   "and even a magical gem from Queen Sugar",$0
    .byte   "herself. Returning to his sewer job on",$0
    .byte   "Earth, the gem is a constant inspiration",$0
    .byte   "in his work.",$0

xorex_ending_data
    .byte   5               ; Line count.
    .byte   "Xorex's demonstration of his power has",$0
    .byte   "brought him unwanted fame and attention.",$0
    .byte   "Retreating to his mountain fortress, his",$0
    .byte   "adoring fans besiege his residence",$0
    .byte   "Can't he just be left alone?",$0

q_sugar_ending_data
    .byte   4               ; Line count.
    .byte   "After defeating her ancient foe, Queen",$0
    .byte   "Sugar's power brings a new era of peace",$0
    .byte   "to Fairy Land. Zevasha is still out",$0
    .byte   "there somewhere.  How long can it last?",$0

zevasha_ending_data
    .byte   7               ; Line count.
    .byte   "With her foes broken and all resistance",$0
    .byte   "crushed, Zevasha's darkness spreads over",$0
    .byte   "Fairy Land. Queen Sugar, her forces, and",$0
    .byte   "even her human allies were no match for",$0
    .byte   "the queen of darkness. Never satisfied,",$0
    .byte   "Zevasha begins plotting the invasion of",$0
    .byte   "Earth.",$0

