; This file is part of Magical Fairy Force.

; Magical Fairy Force is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; Magical Fairy Force is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with Magical Fairy Force.  If not, see <http://www.gnu.org/licenses/>.

; Copyright 2020 Average Software.

; Magical Fairy Force
; Assemble with DASM command line:
; dasm fairy_force.s -f3 -ofairy_force.bin

    processor 6502

    include "hardware.s"
    include "instructions.s"

    org     $4000                   ; Cartridge memory.
    jsr     init_system             ; Run one-time startup code.
    jmp     start_title_screen

    include "startup.s"
    include "utilities.s"
    include "title_screen.s"
    include "character_select.s"
    include "versus_screen.s"
    include "schedule.s"
    include "game.s"
    include "game_over.s"
    include "input.s"
    include "pink_b.s"
    include "frooty.s"
    include "7zcbx.s"
    include "kitty.s"
    include "porkchop.s"
    include "xorex.s"
    include "q_sugar.s"
    include "zevasha.s"
    include "interrupts.s"
    include "data.s"

    org     $bf00                   ; Build watermark.
build_id
    .byte   "Release 1.02, 6/14/2020",$0

; Additional text resources I can't fit anywhere else.
title_text
    .byte   "magical fairy force",$0

game_select_text
    .byte   "Press 1 for 1 player",$0

view_license_text
    .byte   "Press # to view license",$0

copyright_text
    .byte   "Copyright MMXX Average Software",$0

game_over_text
    .byte   "GAME OVER",$0

continue_text
    .byte   "Press Start to continue",$0

give_up_text
    .byte   "Press Reset to give up",$0

    org     $bfe7                   ; PAL flag.
    .byte   $00

    org     $bffd                   ; Cartridge reset data.
    .byte   $ff                     ; No copyright screen.
    .word   $4000                   ; Code starts at $4000.

