; This file is part of Magical Fairy Force.

; Magical Fairy Force is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; Magical Fairy Force is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with Magical Fairy Force.  If not, see <http://www.gnu.org/licenses/>.

; Copyright 2020 Average Software.

; Main game code

player_sprite_rows      equ 20
left_bound              equ 48
right_bound             equ 200
hpos_center             equ 125
p0_top_bound            equ $85
p0_bottom_bound         equ $be
p0_top_move_bound       equ $8d
p1_top_bound            equ $2e
p1_bottom_bound         equ $67
p1_bottom_move_bound    equ $5f
wing_color              equ $08
shot_speed              equ 5
star_duration           equ 240
gauge_low_color         equ $0c
gauge_high_color        equ $4a
gauge_cooldown_color    equ $04
gauge_max_color         equ $10
subpixel_limit          equ 50
p0_scroll_base          equ $880
p0_scroll_erase_start   equ $3c08
p1_scroll_base          equ $817
p1_scroll_wrap_base     equ $85d
hit_invinc_time         equ 120
health_color            equ $33
p0_health_hpos          equ 150
p1_health_hpos          equ 90
shot_color              equ $1f
frame_color             equ $8e
cloud_color             equ $0f
star_color              equ $0f
fairy_dust_color        equ $1c
lightning_color         equ $1c
fuel_timer_max          equ 60
p0_fuel_base            equ $af1
p1_fuel_base            equ $a79
fuel_warning_level      equ 10
fairy_dust_trigger      equ 10
fuel_max_offset         equ 37
speed_up_interval       equ 20
max_speed_index         equ 7
minor_fairy_power       equ 4
max_fairy_power         equ 16
cooldown_time           equ 60
lightning_effect_time   equ 15
fuel_gauge_color        equ $3e

; Shot structure offsets.
shot_hpos           equ 0
shot_vpos           equ 1
shot_hsubpixel      equ 2
shot_vsubpixel      equ 3
shot_hspeed         equ 4
shot_vspeed         equ 5
shot_size           equ 6

; Cloud spawn type constants.
spawn_cloud         equ 0
spawn_fairy_dust    equ 1
spawn_lightning     equ 2

p0_hpos                   equ $19
p1_hpos                   equ $1a
p0_wing_hpos              equ $1b
p1_wing_hpos              equ $1c
p0_color_1                equ $1d
p0_color_2                equ $1e
p0_color_3                equ $1f
p1_color_1                equ $20
p1_color_2                equ $21
p1_color_3                equ $22
p0_gauge_color            equ $23
p0m0_hpos                 equ $24
p0_shot_hpos              equ $25
p0m2_hpos                 equ $26
p0m3_hpos                 equ $27
p1m0_hpos                 equ $28
p1m1_hpos                 equ $29
p1m2_hpos                 equ $2a
p1_shot_hpos              equ $2b
p0_portrait_color         equ $2c
p1_portrait_color         equ $2d
p0_fuel_color             equ $2e
p1_fuel_color             equ $2f
p0_background_color       equ $30
p1_background_color       equ $31
p0_playfield_0_color      equ $32
p0_playfield_1_color      equ $33
p0_playfield_2_color      equ $34
p1_playfield_0_color      equ $35
p1_playfield_1_color      equ $36
p1_playfield_2_color      equ $37
pf_high                   equ $38
mpl_high                  equ $39
pf_low                    equ $3a
mpl_low                   equ $3b

p0m1_hpos           equ p0_shot_hpos
p1m3_hpos           equ p1_shot_hpos

; These page 2 variables are preserved
; across all states.
game_mode           equ $2e0
other_screen_active equ $2e1
p0_character        equ $2e2
p1_character        equ $2e3
schedule_progress   equ $2e4
fight_schedule      equ $2e5

p0_real_wing_hpos   equ $3c
p1_real_wing_hpos   equ $3d
wing_blink          equ $3e
wing_frame          equ $3f
p0_vpos             equ $40
p1_vpos             equ $41
p0_shot_vpos        equ $43
p1_shot_vpos        equ $44
star_timer          equ $45
star_max_timer      equ $46
p0_fairy_power      equ $47
p1_fairy_power      equ $48
p0_star_0_index     equ $49
p0_star_1_index     equ $4a
p1_star_0_index     equ $4b
p1_star_1_index     equ $4c
p0_star_0_ttl       equ $4d
p0_star_1_ttl       equ $4e
p1_star_0_ttl       equ $4f
p1_star_1_ttl       equ $50
p0_blink_flag       equ $51
p1_blink_flag       equ $52
p0_scroll_flag      equ $53
p1_scroll_flag      equ $54
p0_scroll_wrap      equ $55
p1_scroll_wrap      equ $56
next_star           equ $57
p0_cloud_index      equ $58
p0_cloud_offset     equ $59
p1_cloud_index      equ $5a
p1_cloud_offset     equ $5b
p0_random           equ $5c
p1_random           equ $5d
p0_cloud_timer      equ $5e
p1_cloud_timer      equ $5f
p1_cloud_address    equ $60
p0_scroll_target    equ $62
p1_scroll_target    equ $63
p0_hit_invinc       equ $64
p1_hit_invinc       equ $65
p0_real_hpos        equ $66
p1_real_hpos        equ $67
p0_health_mask      equ $68
p1_health_mask      equ $69
p0_scroll_timer     equ $6a
p1_scroll_timer     equ $6b
p0_scroll_speed     equ $6c
p1_scroll_speed     equ $6d
p0_scroll_rate      equ $6e
p1_scroll_rate      equ $6f
dead_player         equ $70
p0_fuel_offset      equ $71
p0_fuel_pattern     equ $72
p1_fuel_offset      equ $73
p1_fuel_pattern     equ $74
fuel_timer          equ $75
p0_clouds           equ $76
p1_clouds           equ $77
p0_cloud_spawn      equ $78
p1_cloud_spawn      equ $79
p0_fairy_dust_index equ $7a
p1_fairy_dust_index equ $7b
p0_cloud_rate       equ $7c
p1_cloud_rate       equ $7d
speed_up_timer      equ $7e
speed_up_frames     equ $7f
speed_index         equ $80
star_shot_mode      equ $81
p0_lightning_flag   equ $82
p1_lightning_flag   equ $83
p0_attack_active    equ $84
p1_attack_active    equ $85
p0_scroll_erase     equ $86
p0w0_shot           equ $88
p0w1_shot           equ p0w0_shot + shot_size
p1w0_shot           equ p0w1_shot + shot_size
p1w1_shot           equ p1w0_shot + shot_size

; CPU variables.
cpu_hspeed          equ $a0
cpu_vspeed          equ $a1
cpu_xdest           equ $a2
cpu_ydest           equ $a3
cpu_state           equ $a4
cpu_cloud_index     equ $a5
cpu_star_index      equ $a6
cpu_star_seek_odds  equ $a7
cpu_attack_odds     equ $a8
cpu_star_avoid      equ $a9
cpu_big_attack      equ $aa
cpu_left_speed      equ $ab
cpu_right_speed     equ $ac
cpu_up_speed        equ $ad
cpu_down_speed      equ $ae
cpu_attack_routine  equ $af

neutral_bg_color    equ $b1
current_cloud_color equ $b2

p0_cloud_hpos       equ $410
p0_cloud_vpos       equ $418
p1_cloud_hpos       equ $420
p1_cloud_vpos       equ $428
p0_cloud_low_byte   equ $430
p0_cloud_high_byte  equ $438
p1_cloud_low_byte   equ $440
p1_cloud_high_byte  equ $448
p0_cloud_type       equ $450
p1_cloud_type       equ $458
p0_next_cloud       equ $460
p1_next_cloud       equ $461
p0_start_attack     equ $462
p0_process_attack   equ $464
p1_start_attack     equ $466
p1_process_attack   equ $468
p0_attack_cooldown  equ $46a
p1_attack_cooldown  equ $46b
p0_bg_effect_timer  equ $46c
p1_bg_effect_timer  equ $46d

p0_attack_data      equ $500
p1_attack_data      equ $600

; Entry point for the game state.
start_game subroutine
    mwa     ENDINT,VVBLKD           ; Shut down the vblank interrupt.
    lda     #<null_display_list     ; Temp display list for a clean
    sta     sDLISTL                 ; transition between modes.
    sta     DLISTL
    lda     #>null_display_list
    sta     sDLISTH
    sta     DLISTH
    jsr     hide_all_sprites
    jsr     safe_clear_page_0
    lda     #3                      ; Start clearing RAM from page 3.
    sta     $ff
.ram_clear_loop
    jsr     clear_page
    ldy     $ff
    cpy     #$3f
    beq     .ram_clear_done
    inc     $ff
    jmp     .ram_clear_loop
.ram_clear_done
    jsr     build_byte_reverse_table
    lda     #p0_scroll_base - #$800 + #3
    sta     p0_scroll_wrap
    mwa     p0_scroll_erase_start,p0_scroll_erase
    lda     #p1_scroll_wrap_base - $800
    sta     p1_scroll_wrap
    ldy     p0_character            ; Set up the player data.
    lda     cpu_routine_low,y       ; Set the CPU attack routine.
    sta     cpu_attack_routine
    lda     cpu_routine_high,y
    sta     cpu_attack_routine + 1
    lda     player_sprite_p1_colors,y
    sta     p0_color_1
    lda     player_sprite_p2_colors,y
    sta     p0_color_2
    lda     player_sprite_p3_colors,y
    sta     p0_color_3
    lda     game_portrait_color_offset,y
    sta     p0_portrait_color
    lda     portrait_color_low,y    ; Build the portrait color table.
    sta     $f6
    lda     portrait_color_high,y
    sta     $f7
    mwa     p0_portrait_table_0,$fe
    jsr     wait_for_vb
    jsr     decompress_portrait_table
    ldy     p0_character
    lda     player_portrait_data_low,y
    sta     $f6                     ; Set up the portrait pointer.
    lda     player_portrait_data_high,y
    sta     $f7
    lda     start_attack_vectors_low,y
    sta     p0_start_attack
    lda     start_attack_vectors_high,y
    sta     p0_start_attack + 1
    lda     process_attack_vectors_low,y
    sta     p0_process_attack
    lda     process_attack_vectors_high,y
    sta     p0_process_attack + 1
    lda     #$00                    ; Place at $e00
    sta     $f0
    sta     sCOLPM2                 ; Sneak these 0s in.
    sta     sCOLPM3
    lda     #$0e
    sta     $f1
    jsr     wait_for_vb
    lda     game_portrait_offset,y
    jsr     copy_portrait
    ldy     p0_character
    lda     sprite_base_high,y
    sta     $fb
    lda     sprite_base_low,y
    sta     $fa
    clc
    adc     #player_sprite_rows
    sta     $fc
    lda     $fb
    adc     #0
    sta     $fd
    lda     $fc
    clc
    adc     #player_sprite_rows
    sta     $fe
    lda     $fd
    adc     #0
    sta     $ff
    ldx     #0                      ; Index into the PM memory.
    ldy     #0                      ; Index into the sprite data.
.p0_sprite_loop
    lda     ($fa),y
    sta     $15b0,x
    lda     ($fc),y
    sta     $16b0,x
    lda     ($fe),y
    sta     $17b0,x
    iny
    cpy     #player_sprite_rows
    beq     .p0_sprite_loop_done
    inx
    jmp     .p0_sprite_loop
.p0_sprite_loop_done
    ldy     p1_character
    lda     player_sprite_p1_colors,y
    sta     p1_color_1
    lda     player_sprite_p2_colors,y
    sta     p1_color_2
    lda     player_sprite_p3_colors,y
    sta     p1_color_3
    lda     portrait_color_low,y    ; Build the portrait color table.
    sta     $f6
    lda     portrait_color_high,y
    sta     $f7
    mwa     p1_portrait_table_0,$fe
    jsr     wait_for_vb
    jsr     decompress_portrait_table
    ldy     p1_character
    lda     player_portrait_data_low,y
    sta     $f6
    lda     player_portrait_data_high,y
    sta     $f7
    lda     start_attack_vectors_low,y
    sta     p1_start_attack
    lda     start_attack_vectors_high,y
    sta     p1_start_attack + 1
    lda     process_attack_vectors_low,y
    sta     p1_process_attack
    lda     process_attack_vectors_high,y
    sta     p1_process_attack + 1
    lda     #$19                    ; Place at $c19
    sta     $f0
    lda     #$0c
    sta     $f1
    jsr     wait_for_vb
    lda     game_portrait_offset,y
    jsr     copy_portrait_mirrored
    ldy     p1_character
    lda     sprite_base_low,y
    sta     $fc
    lda     sprite_base_high,y
    sta     $fd
    lda     game_portrait_color_offset,y
    sta     p1_portrait_color
    mwa     $153b,$fe
    jsr     copy_sprite_180
    inc     $ff
    lda     $fc
    clc
    adc     #player_sprite_rows
    sta     $fc
    lda     $fd
    adc     #0
    sta     $fd
    jsr     copy_sprite_180
    inc     $ff
    lda     $fc
    clc
    adc     #player_sprite_rows
    sta     $fc
    lda     $fd
    adc     #0
    sta     $fd
    jsr     copy_sprite_180
    mva     #background_color,sCOLBK
    sta     COLBK
    sta     p0_background_color
    sta     p1_background_color
    sta     neutral_bg_color
    mva     #frame_color,sCOLOR0
    lda     #gauge_low_color
    sta     sCOLPM0
    sta     sCOLPM1
    sta     p0_gauge_color
    lda     #$3f                    ; Mask to be applied on the next
    sta     p0_health_mask          ; player hit.
    lda     #$fc
    sta     p1_health_mask
    sta     p0_fuel_pattern         ; Mask for the fuel drain.
    sta     p1_fuel_pattern
    lda     #fuel_max_offset
    sta     p0_fuel_offset
    sta     p1_fuel_offset
    lda     #fuel_timer_max
    sta     fuel_timer
    lda     #speed_up_interval
    sta     speed_up_timer
    lda     #60
    sta     speed_up_frames
    lda     #$55
    ldy     #79
.border_loop
    sta     $1000,y
    dey
    bpl     .border_loop
    ldy     #39
    lda     #$55
.center_lines_loop
    sta     $a00,y
    sta     $b68,y
    dey
    bpl     .center_lines_loop
    ldy     #37
    lda     #$aa
.center_gauges_loop
    sta     $a79,y
    sta     $af1,y
    dey
    bpl     .center_gauges_loop
    lda     #$11                    ; Clear the decompression data
    sta     $ff                     ; on page $11.
    jsr     clear_page
    lda     #120
    sta     star_max_timer
    lda     #60
    sta     star_timer
    lda     #hpos_center
    sta     p0_real_hpos
    sta     p1_real_hpos
    lda     #121
    sta     p0_real_wing_hpos
    sta     p1_real_wing_hpos
    mva     #$b0,p0_vpos
    mva     #$3b,p1_vpos
    mva     #$11,PRIOR
    mva     #health_color,COLPF3
    sta     sCOLOR3
    lda     scroll_rate_table
    sta     p0_scroll_timer
    sta     p1_scroll_timer
    sta     p0_scroll_rate
    sta     p1_scroll_rate
    lda     #1
    sta     p0_scroll_speed
    sta     p1_scroll_speed
    ldy     #6
    lda     #$ff
.power_gauge_loop
    sta     $1323,y
    sta     $13d5,y
    sta     $1623,y
    sta     $16d5,y
    dey
    bne     .power_gauge_loop
.random_seed_loop
    lda     RANDOM                  ; Seed the random engine.
    beq     .random_seed_loop       ; 0 doesn't work.
    sta     p0_random
    sta     p1_random
    lda     #-1
    sta     p0_star_0_index
    sta     p0_star_1_index
    sta     p1_star_0_index
    sta     p1_star_1_index
    ldx     #7
.cloud_hpos_loop
    sta     p0_cloud_hpos,x         ; -1 in hpos indicates an
    sta     p1_cloud_hpos,x         ; inactive cloud.
    dex
    bpl     .cloud_hpos_loop
    lda     #fuel_gauge_color       ; Set the gauge coloring.
    sta     p0_fuel_color
    sta     p1_fuel_color
    lda     #cloud_color
    sta     p0_playfield_0_color    ; Set the cloud coloring.
    sta     p1_playfield_0_color
    sta     current_cloud_color
    lda     #lightning_color
    sta     p0_playfield_1_color
    sta     p1_playfield_1_color
    lda     #fairy_dust_color
    sta     p0_playfield_2_color
    sta     p1_playfield_2_color
    lda     cloud_rate_table
    sta     p0_cloud_rate
    sta     p1_cloud_rate
    lda     #1
    sta     p0_cloud_timer
    sta     p1_cloud_timer
    lda     #0                      ; Put the display list at $800.
    sta     $fe
    lda     #8
    sta     $ff
    mwa     game_display_list_header,$fc
    ldy     #game_display_list_center - #game_display_list_header
    jsr     copy_memory
    lda     #$60
    sta     $fe
    mwa     game_display_list_center,$fc
    ldy     #game_display_list_bottom - #game_display_list_center
    jsr     copy_memory
    lda     #$c9
    sta     $fe
    mwa     game_display_list_bottom,$fc
    ldy     #end_game_display_list - #game_display_list_bottom
    jsr     copy_memory
    jsr     reset_player_0_scroll
    jsr     reset_player_1_scroll
    lda     game_mode               ; Activate CPU control for
    cmp     #1                      ; the top player if needed.
    bne     .two_player
    lda     #controller_cpu
    sta     p1_controller_type
    ldy     schedule_progress
    lda     cpu_hspeed_table,y
    sta     cpu_right_speed
    eor     #$ff
    clc
    adc     #1
    sta     cpu_left_speed
    lda     cpu_vspeed_table,y
    sta     cpu_down_speed
    eor     #$ff
    adc     #1
    sta     cpu_up_speed
    lda     cpu_attack_odds_table,y
    sta     cpu_attack_odds
.two_player
    lda     #0
    sta     sDLISTL
    lda     #8
    sta     sDLISTL + 1
    mwa     game_vblank,VVBLKD
    mwa     $ac00,VDSLST
    sta     HITCLR
    lda     #0
    sta     pf_high
    sta     mpl_high
    sta     pf_low
    sta     mpl_low
    ; Fall through to the start loop.

; This macro defines the movement code for each player.
; {1} Player horizontal input.
; {2} Player horizontal position.
; {3} Player wing horizontal position.
; {4} Player vertical input.
; {5} Player vertical position.
; {6} Player upper boundary.
; {7} Player lower boundary.
    mac process_input
    ldx     {1}                     ; Read the h_input.
    txa
    clc
    adc     {2}                     ; Add it to the hpos.
    cmp     #left_bound
    bcs     .left_ok
    lda     #left_bound             ; Past the left edge.
    sta     {2}
    lda     #left_bound - 4
    sta     {3}
    jmp     .check_vertical
.left_ok
    cmp     #right_bound
    bcc     .right_ok
    lda     #right_bound            ; Past the right edge.
    sta     {2}
    lda     #right_bound - 4
    sta     {3}
    jmp     .check_vertical
.right_ok
    sta     {2}                     ; Update hpos.
    txa
    clc
    adc     {3}                     ; Update wing hpos.
    sta     {3}
.check_vertical
    ldy     {4}                     ; Get the v_input.
    bne     .check_v_bounds
    jmp     .done                   ; Do nothing on 0.
.check_v_bounds
    tya
    clc
    adc     {5}                     ; Calculate the new vpos.
    cmp     #{6}
    bcs     .top_ok
    lda     {5}                     ; Past the top.
    sec
    sbc     #{6}                    ; Find the delta for image movement.
    beq     .done                   ; Already at the top.
    tay
    lda     {5}                     ; Old vpos, for image movement.
    ldx     #{6}
    stx     {5}                     ; Set vpos to the boundary.
    jsr     move_player_up
    jmp     .done
.top_ok
    cmp     #{7}
    bcc     .bottom_ok
    lda     #{7}                    ; Past the bottom.
    sec
    sbc     {5}                     ; Find the delta for image movement.
    beq     .done                   ; Already at the bottom.
    tay
    lda     {5}                     ; Old vpos, for image movement.
    ldx     #{7}
    stx     {5}                     ; Set vpos to the boundary.
    jsr     move_player_down
    jmp     .done
.bottom_ok
    ldx     {5}                     ; Old vpos, for image movement.
    sta     {5}                     ; Update vpos.
    cpy     #0                      ; Figure out the direction.
    bmi     .move_up
    txa
    jsr     move_player_down
    jmp     .done
.move_up
    tya                             ; Get absolute value of the delta.
    eor     #$ff
    tay
    iny
    txa
    jsr     move_player_up
.done
    endm

; Game lead-in loop.
game_lead_loop subroutine
    ldy     #180                    ; Pause for 3 seconds.
    jsr     wait_for_y_frames
    ; Fall through to the main game loop.

; Main game processing loop.
game_loop subroutine
    jsr     wait_for_vb
    lda     last_key_pressed        ; Check for pause.
    bmi     .no_key
    cmp     #$0d
    bne     .no_key
    mva     #$ff,last_key_pressed
    jmp     pause_loop
.no_key
    jsr     read_inputs
    lda     p0_trig1
    bne     .p0_shoot_done
    lda     p0_shot_vpos            ; If not 0, the shot is already
    bne     .p0_shoot_done          ; active and should be ignored.
    ldx     p0_real_hpos
    inx
    inx
    stx     p0_shot_hpos
    inx
    inx
    stx     p0m0_hpos
    ldy     p0_vpos
    sty     p0_shot_vpos
    lda     #$09
    ora     $1302,y
    sta     $1302,y
    lda     #$0f
    ora     $1301,y
    sta     $1301,y
    lda     #$06
    ora     $1300,y
    sta     $1300,y
    jsr     play_player_shot_sound
.p0_shoot_done
    lda     p1_trig1
    bne     .p1_shoot_done
    lda     p1_shot_vpos
    bne     .p1_shoot_done
    ldx     p1_real_hpos
    inx
    inx
    stx     p1_shot_hpos
    inx
    inx
    stx     p1m2_hpos
    lda     p1_vpos
    adc     #player_sprite_rows - 2
    tay
    sty     p1_shot_vpos
    lda     #$60
    ora     $1302,y
    sta     $1302,y
    lda     #$f0
    ora     $1301,y
    sta     $1301,y
    lda     #$90
    ora     $1300,y
    sta     $1300,y
    jsr     play_player_shot_sound
.p1_shoot_done
    lda     p0_attack_active        ; Process active attacks.
    beq     .no_p0_attack_active
    lda     #1                      ; Attack target.
    jmp     (p0_process_attack)
.no_p0_attack_active
    ldy     p1_playfield_1_color    ; Strobe lightning.
    iny
    cpy     #$20
    bne     .store_p1_lightning_strobe
    ldy     #$10
.store_p1_lightning_strobe
    sty     p1_playfield_1_color
p0_process_return
    lda     p1_attack_active
    beq     .no_p1_attack_active
    lda     #0                      ; Attack target.
    jmp     (p1_process_attack)
.no_p1_attack_active
    ldy     p0_playfield_1_color    ; Strobe lightning.
    iny
    cpy     #$20
    bne     .store_p0_lightning_strobe
    ldy     #$10
.store_p0_lightning_strobe
    sty     p0_playfield_1_color
p1_process_return
    lda     p0_attack_cooldown      ; Process the cooldown timers.
    beq     .p0_cooldown_ok
    dec     p0_attack_cooldown
    bne     .p0_cooldown_ok
    ldx     #0                      ; Reset the color.
    jsr     apply_p0_fairy_power
.p0_cooldown_ok
    lda     p1_attack_cooldown
    beq     .p1_cooldown_ok
    dec     p1_attack_cooldown
    bne     .p1_cooldown_ok
    ldx     #0                      ; Reset the color.
    jsr     apply_p1_fairy_power
.p1_cooldown_ok
    lda     p0_bg_effect_timer      ; Check the effect timers.
    beq     .p0_effect_timer_ok
    dec     p0_bg_effect_timer
    bne     .p0_effect_timer_ok
    ldy     p0_background_color     ; Update the background color.
    dey
    dey
    sty     p0_background_color
    cpy     neutral_bg_color        ; Check for effect end.
    beq     .p0_effect_timer_ok
    lda     #lightning_effect_time
    sta     p0_bg_effect_timer      ; Reset the timer.
.p0_effect_timer_ok
    lda     p1_bg_effect_timer
    beq     .p1_effect_timer_ok
    dec     p1_bg_effect_timer
    bne     .p1_effect_timer_ok
    ldy     p1_background_color
    dey
    dey
    sty     p1_background_color
    cpy     neutral_bg_color
    beq     .p1_effect_timer_ok
    lda     #lightning_effect_time
    sta     p1_bg_effect_timer
.p1_effect_timer_ok
    lda     p1_trig2
    beq     .no_p1_trig2
    lda     p1_attack_active
    bne     .input_done             ; Attack in progress, skip.
    lda     p1_attack_cooldown      ; Check the cooldown.
    bne     .input_done             ; Still in cooldown.
    lda     p0_lightning_flag       ; Make sure the last attack processed.
    bne     .input_done             ; Still waiting on the last attack.
    lda     p1_fairy_power          ; See if there's enough fairy power
    cmp     #max_fairy_power        ; to launch an attack.
    beq     .p1_big_attack
    cmp     #minor_fairy_power
    bmi     .input_done
    ldx     -#minor_fairy_power
    jsr     apply_p1_fairy_power
    lda     #1                      ; Set the lightning flag.
    sta     p0_lightning_flag
    lda     #cooldown_time          ; Set the cooldown.
    sta     p1_attack_cooldown
    lda     #gauge_cooldown_color   ; Set the gauge color.
    sta     sCOLPM0
    sta     sCOLPM1
    jmp     .input_done
.p1_big_attack
    lda     #0                      ; Target player.
    jmp     (p1_start_attack)
.no_p1_trig2
    lda     p0_trig2
    beq     .input_done
    lda     p0_attack_active
    bne     .input_done             ; Attack in progress, skip.
    lda     p0_attack_cooldown      ; Check the cooldown.
    bne     .input_done             ; Still in cooldown.
    lda     p1_lightning_flag       ; Make sure the last attack processed.
    bne     .input_done             ; Still waiting on the last attack.
    lda     p0_fairy_power          ; See if there's enough fairy power
    cmp     #max_fairy_power        ; to launch an attack.
    beq     .p0_big_attack
    cmp     #minor_fairy_power
    bmi     .input_done
    ldx     -#minor_fairy_power
    jsr     apply_p0_fairy_power
    lda     #1                      ; Set the lightning flag.
    sta     p1_lightning_flag
    lda     #cooldown_time          ; Set the cooldown.
    sta     p0_attack_cooldown
    lda     #gauge_cooldown_color   ; Set the gauge color.
    sta     p0_gauge_color
    jmp     .input_done
.p0_big_attack
    lda     #1                      ; Target player.
    jmp     (p0_start_attack)
start_attack_return
.input_done
    lda     p0_hit_invinc           ; Process hit timers.
    beq     .p0_hit_invinc_ok
    dec     p0_hit_invinc
.p0_hit_invinc_ok
    lda     p1_hit_invinc
    beq     .p1_hit_invinc_ok
    dec     p1_hit_invinc
.p1_hit_invinc_ok
    ldy     p0_shot_vpos
    beq     .p0_shot_done
    ldx     #$f0
    txa
    and     $1300,y
    sta     $1300,y
    txa
    and     $1301,y
    sta     $1301,y
    txa
    and     $1302,y
    sta     $1302,y
    tya
    sec
    sbc     #shot_speed
    cmp     #p0_top_bound
    bcc     .p0_clear_shot
    beq     .p0_clear_shot
    tay
    lda     #$09
    ora     $1302,y
    sta     $1302,y
    lda     #$0f
    ora     $1301,y
    sta     $1301,y
    lda     #$06
    ora     $1300,y
    sta     $1300,y
    sty     p0_shot_vpos
    jmp     .p0_shot_done
.p0_clear_shot
    lda     #0
    sta     p0_shot_hpos
    sta     p0_shot_vpos
.p0_shot_done
    ldy     p1_shot_vpos
    beq     .p1_shot_done
    ldx     #$0f
    txa
    and     $1300,y
    sta     $1300,y
    txa
    and     $1301,y
    sta     $1301,y
    txa
    and     $1302,y
    sta     $1302,y
    tya
    clc
    adc     #shot_speed
    cmp     #p1_bottom_bound + #player_sprite_rows - 2
    bcs     .p1_clear_shot
    tay
    lda     #$60
    ora     $1302,y
    sta     $1302,y
    lda     #$f0
    ora     $1301,y
    sta     $1301,y
    lda     #$90
    ora     $1300,y
    sta     $1300,y
    sty     p1_shot_vpos
    jmp     .p1_shot_done
.p1_clear_shot
    lda     #0
    sta     p1_shot_hpos
    sta     p1_shot_vpos
.p1_shot_done
    mvx     #0,$ff                  ; Amount of fairy power to add.
    lda     p0_shot_vpos            ; Check for star hits.
    beq     .p0_star_hits_done
    cmp     #p0_top_bound + 8
    bcs     .p0_star_hits_done
    lda     p0_shot_hpos
    jsr     check_star_hits
    cpx     p0_star_0_index
    beq     .p0_star_0_hit
    cpy     p0_star_0_index
    bne     .p0_star_0_hit_done
.p0_star_0_hit
    lda     #1                      ; Set the TTL to 1 and the following
    sta     p0_star_0_ttl           ; logic will remove the star.
    inc     $ff                     ; Add more fairy power.
.p0_star_0_hit_done
    cpx     p0_star_1_index         ; See if there's a second hit.
    beq     .p0_star_1_hit
    cpy     p0_star_1_index
    bne     .p0_star_hits_done
.p0_star_1_hit
    lda     #1
    sta     p0_star_1_ttl
    inc     $ff                     ; Add more fairy power.
.p0_star_hits_done
    ldx     $ff
    beq     .no_p0_power_change
    jsr     apply_p0_fairy_power
    mwa     star_hit_sound,$fe
    jsr     play_sound_1
.no_p0_power_change
    lda     p1_shot_vpos            ; Repeat for the other player.
    mvx     #0,$ff
    cmp     #p1_bottom_bound + #player_sprite_rows - 8
    bcc     .p1_star_hits_done
    lda     p1_shot_hpos
    jsr     check_star_hits
    stx     $fe
    lda     #39
    sec
    sbc     $fe
    tax
    sty     $fe
    lda     #39
    sec
    sbc     $fe
    tay
    cpx     p1_star_0_index
    beq     .p1_star_0_hit
    cpy     p1_star_0_index
    bne     .p1_star_1_hit_done
.p1_star_0_hit
    lda     #1
    sta     p1_star_0_ttl
    inc     $ff
.p1_star_1_hit_done
    cpx     p1_star_1_index
    beq     .p1_star_1_hit
    cpy     p1_star_1_index
    bne     .p1_star_hits_done
.p1_star_1_hit
    lda     #1
    sta     p1_star_1_ttl
    inc     $ff
.p1_star_hits_done
    ldx     $ff
    beq     .no_p1_power_change
    jsr     apply_p1_fairy_power
    mwa     star_hit_sound,$fe
    jsr     play_sound_1
.no_p1_power_change
    lda     p1_attack_active        ; Skip the collision detection
    bne     .p0_cloud_coll_done     ; when an attack is active.
    jsr     find_p0_hit_cloud       ; Check for a hit.
    bmi     .p0_cloud_coll_done     ; No hit on negative.
    lda     p0_cloud_type,y         ; See what got shot.
    cmp     #spawn_lightning
    beq     .p0_lightning_hit
    cmp     #spawn_cloud
    bne     .p0_cloud_coll_done
    jsr     erase_player_0_cloud    ; Shot a cloud.
    mwa     cloud_hit_sound,$fe
    jsr     play_sound_1
    inc     p0_clouds
    bne     .p0_cloud_coll_done     ; Always true.
.p0_lightning_hit
    jsr     erase_player_0_cloud
    mwa     lightning_hit,$fe
    jsr     play_sound_4
    ldx     #minor_fairy_power / 2  ; Award fairy power.
    jsr     apply_p0_fairy_power
.p0_cloud_coll_done
    lda     p0_attack_active        ; Skip the collision detection
    bne     .p1_cloud_coll_done     ; when an attack is active.
    jsr     find_p1_hit_cloud       ; Check for a hit.
    bmi     .p1_cloud_coll_done     ; No hit on negative.
    lda     p1_cloud_type,y         ; See what got shot.
    cmp     #spawn_lightning
    beq     .p1_lightning_hit
    cmp     #spawn_cloud
    bne     .p1_cloud_coll_done
    jsr     erase_player_1_cloud    ; Shot a cloud.
    mwa     cloud_hit_sound,$fe
    jsr     play_sound_1
    inc     p1_clouds
    bne     .p1_cloud_coll_done     ; Always true.
.p1_lightning_hit
    jsr     erase_player_1_cloud
    mwa     lightning_hit,$fe
    jsr     play_sound_3
    ldx     #minor_fairy_power / 2
    jsr     apply_p1_fairy_power
.p1_cloud_coll_done
    lda     p0_scroll_flag          ; See if the scroll finished.
    bpl     .p0_scroll_ignore       ; Ignore if not negative.
    cmp     #-2                     ; -2 means scroll is disabled.
    beq     .p0_scroll_ignore
    inc     p0_scroll_flag          ; Reset to 0.
    lda     p0_scroll_rate          ; Reset the timer.
    sta     p0_scroll_timer
    ldy     #7                      ; Index every cloud.
.p0_cloud_process_loop
    lda     p0_cloud_hpos,y         ; Check for activity.
    cmp     #-1
    beq     .p0_process_next_cloud  ; Inactive on negative.
    lda     p0_cloud_vpos,y         ; Update the vpos.
    clc
    adc     p0_scroll_target
    sta     p0_cloud_vpos,y
    cmp     #p0_bottom_bound + #player_sprite_rows + #8
    bne     .p0_process_next_cloud  ; Check for fall-off.
    jsr     erase_player_0_cloud
    lda     p0_cloud_type,y         ; Check for lightning.
    cmp     #spawn_lightning
    bne     .p0_process_next_cloud
    jsr     damage_player_0_force
.p0_process_next_cloud
    dey                             ; Drop the index.
    bpl     .p0_cloud_process_loop
.p0_scroll_ignore
    lda     p1_scroll_flag          ; See if the scroll finished.
    bpl     .p1_scroll_ignore       ; Ignore if not negative.
    cmp     #-2                     ; -2 means scroll is disabled.
    beq     .p1_scroll_ignore
    inc     p1_scroll_flag          ; Reset to 0.
    lda     p1_scroll_rate          ; Reset the timer.
    sta     p1_scroll_timer
    ldy     #7                      ; Index every cloud.
.p1_cloud_process_loop
    lda     p1_cloud_hpos,y         ; Check for activity.
    cmp     #-1
    beq     .p1_process_next_cloud  ; Inactive on negative.
    lda     p1_cloud_vpos,y         ; Update the vpos.
    sec
    sbc     p1_scroll_target
    sta     p1_cloud_vpos,y
    cmp     #p1_top_bound - #8
    bne     .p1_process_next_cloud  ; Check for fall-off.
    jsr     erase_player_1_cloud
    lda     p1_cloud_type,y         ; Check for lightning.
    cmp     #spawn_lightning
    bne     .p1_process_next_cloud
    jsr     damage_player_1_force
.p1_process_next_cloud
    dey
    bpl     .p1_cloud_process_loop
.p1_scroll_ignore
    dec     p0_cloud_timer
    bne     .p0_cloud_spawn_done
    lda     p0_cloud_rate           ; Reset the spawn timer.
    sta     p0_cloud_timer
    ldy     #7                      ; Try to find an open location.
.p0_cloud_search_loop
    lda     p0_cloud_hpos,y         ; -1 hpos indicates an inactive
    cmp     #-1                     ; location we can use.
    beq     .p0_cloud_search_done
    dey
    bpl     .p0_cloud_search_loop
    jmp     .p0_cloud_spawn_done    ; No location found.
.p0_cloud_search_done
    sty     p0_next_cloud           ; Save the index.
    lda     #p0_top_bound + 8       ; Set the vpos.
    sta     p0_cloud_vpos,y
    jsr     get_player_0_random
    and     #$3f
    cmp     #40
    bcc     .p0_cloud_random_ok
    sec
    sbc     #40
.p0_cloud_random_ok
    and     #$fe                    ; Make the value even.
    pha                             ; Save it.
    lda     p0_clouds
    sty     $ff                     ; Save the index.
    ldy     #0
    jsr     determine_object_spawn  ; Figure out what to spawn.
    ldy     $ff                     ; Get the index back.
    sta     p0_clouds
    stx     p0_cloud_spawn
    txa
    sta     p0_cloud_type,y
    cpx     #spawn_fairy_dust       ; Save the fairy dust index.
    bne     .p0_not_fairy_dust
    sty     p0_fairy_dust_index
.p0_not_fairy_dust
    pla                             ; Get the position back.
    sta     p0_cloud_index
    asl                             ; Multiply by 4 and add to the
    asl                             ; left boundary to get the hpos.
    clc
    adc     #left_bound
    sta     p0_cloud_hpos,y
    lda     #0                      ; Blank the adddress.
    sta     p0_cloud_low_byte,y
    sta     p0_cloud_high_byte,y
    lda     #14
    sta     p0_cloud_offset
.p0_cloud_spawn_done
    dec     p1_cloud_timer
    bne     .p1_cloud_spawn_done
    lda     p1_cloud_rate           ; Reset the spawn timer.
    sta     p1_cloud_timer
    ldy     #7                      ; Try to find an open location.
.p1_cloud_search_loop
    lda     p1_cloud_hpos,y         ; -1 hpos indicates an inactive
    cmp     #-1                     ; location we can use.
    beq     .p1_cloud_search_done
    dey
    bpl     .p1_cloud_search_loop
    jmp     .p1_cloud_spawn_done    ; No location found.
.p1_cloud_search_done
    sty     p1_next_cloud           ; Save the index.
    lda     #p1_bottom_bound + #player_sprite_rows - 8
    sta     p1_cloud_vpos,y         ; Set the vpos.
    jsr     get_player_1_random
    and     #$3f
    cmp     #40
    bcc     .p1_cloud_random_ok
    sec
    sbc     #40
.p1_cloud_random_ok
    and     #$fe                    ; Make the value even.
    pha                             ; Save it.
    lda     p1_clouds
    sty     $ff                     ; Save the index.
    ldy     #1
    jsr     determine_object_spawn  ; Figure out what to spawn.
    ldy     $ff                     ; Get the index back.
    sta     p1_clouds
    stx     p1_cloud_spawn
    txa
    sta     p1_cloud_type,y
    cpx     #spawn_fairy_dust       ; Save the fairy dust index.
    bne     .p1_not_fairy_dust
    sty     p1_fairy_dust_index
.p1_not_fairy_dust
    pla                             ; Get the position back.
    sta     p1_cloud_index
    asl                             ; Multiply by 4 and subtract
    asl                             ; from the right bound to get
    sta     $ff                     ; the hpos.
    lda     #right_bound
    sec
    sbc     $ff
    sta     p1_cloud_hpos,y
    lda     #0                      ; Blank the address.
    sta     p1_cloud_low_byte,y
    sta     p1_cloud_high_byte,y
    lda     #14
    sta     p1_cloud_offset
.p1_cloud_spawn_done
    lda     mpl_low                 ; Check for star shot hits.
    and     #$0e                    ; Ignore the P0 (wing) hits.
    beq     .no_p0_star_shot_hit
    jsr     damage_player_0
.no_p0_star_shot_hit
    lda     mpl_high                ; Check for star shot hits.
    and     #$0e                    ; Ignore the P0 (wing) hits.
    beq     .no_p1_star_shot_hit
    jsr     damage_player_1
.no_p1_star_shot_hit
    dec     fuel_timer              ; Adjust the fuel gauges.
    bne     .fuel_done
    lda     #fuel_timer_max         ; Reset the timer.
    sta     fuel_timer
    jsr     drop_player_0_fuel
    jsr     drop_player_1_fuel
.fuel_done
    ldy     p0_fuel_offset          ; See if the fuel has run out
    cpy     #-1                     ; for either player.
    beq     .fuel_out
    ldy     p1_fuel_offset
    cpy     #-1
    bne     .fuel_ok
.fuel_out
    jmp     fuel_out_loop
.fuel_ok
    lda     p0_hit_invinc           ; No hazard contact while in
    ora     p1_attack_active        ; hit-blink or when attack is active.
    bne     .no_p0_hazard_contact
    lda     pf_low
    pha                             ; Save the value.
    and     #1
    beq     .no_p0_cloud_contact
    mwa     cloud_sound,$fe
    jsr     play_sound_4
    jsr     drop_player_0_fuel
.no_p0_cloud_contact
    pla                             ; Get the collisions back.
    and     #2
    beq     .no_p0_hazard_contact
    jsr     damage_player_0
.no_p0_hazard_contact
    lda     p1_hit_invinc           ; No hazard contact while in
    ora     p0_attack_active        ; hit-blink or when attack is active.
    bne     .no_p1_hazard_contact
    lda     pf_high
    pha                             ; Save the value.
    and     #1
    beq     .no_p1_cloud_contact
    mwa     cloud_sound,$fe
    jsr     play_sound_3
    jsr     drop_player_1_fuel
.no_p1_cloud_contact
    pla                             ; Get the collisions back.
    and     #2
    beq     .no_p1_hazard_contact
    jsr     damage_player_1
.no_p1_hazard_contact
    ; Handle player movement here, so it doesn't happen
    ; before the death loop.  This prevents the apeearance
    ; of bad collisions.
    process_input p0_h_input,p0_real_hpos,p0_real_wing_hpos,p0_v_input,p0_vpos,p0_top_move_bound,p0_bottom_bound
    process_input p1_h_input,p1_real_hpos,p1_real_wing_hpos,p1_v_input,p1_vpos,p1_top_bound,p1_bottom_move_bound
    ldx     p0_fuel_color           ; Strobe the fuel colors.
    cpx     #fuel_gauge_color
    beq     .no_p0_fuel_strobe
    cpx     #$4e
    beq     .reset_p0_strobe
    inx
    .byte   $2c
.reset_p0_strobe
    ldx     #$40
    stx     p0_fuel_color
.no_p0_fuel_strobe
    ldx     p1_fuel_color
    cpx     #fuel_gauge_color
    beq     .no_p1_fuel_strobe
    cpx     #$4e
    beq     .reset_p1_strobe
    inx
    .byte   $2c
.reset_p1_strobe
    ldx     #$40
.store_p1_strobe
    stx     p1_fuel_color
.no_p1_fuel_strobe
    lda     p1_attack_active        ; Skip when attacks are active.
    bne     .no_p0_fairy_dust
    lda     pf_low                  ; Check for fairy dust pickup.
    and     #4
    beq     .no_p0_fairy_dust
    mwa     fairy_dust_sound,$fe
    jsr     play_sound_4
    ldy     p0_fairy_dust_index
    jsr     erase_player_0_cloud    ; Erase the fairy dust.
    ldy     p0_fuel_offset          ; Adjust the fuel gauge.
    lda     #$aa
    ldx     #3                      ; Fill 3 blocks.
.p0_restore_fuel_loop
    sta     p0_fuel_base,y
    cpy     #fuel_max_offset
    beq     .p0_full_fuel
    iny
    dex
    bne     .p0_restore_fuel_loop
    and     p0_fuel_pattern         ; Mask the last block.
    sta     p0_fuel_base,y
    jmp     .p0_update_fuel_offset
.p0_full_fuel
    lda     #$fc
    sta     p0_fuel_pattern
.p0_update_fuel_offset
    sty     p0_fuel_offset
    cpy     #fuel_warning_level + 1
    bmi     .no_p0_fairy_dust
    lda     #fuel_gauge_color       ; Reset the gauge color.
    sta     p0_fuel_color
.no_p0_fairy_dust
    lda     p0_attack_active        ; Skip when attacks are live.
    bne     .no_p1_fairy_dust
    lda     pf_high                 ; Repeat for player 1.
    and     #4
    beq     .no_p1_fairy_dust
    mwa     fairy_dust_sound,$fe
    jsr     play_sound_3
    ldy     p1_fairy_dust_index
    jsr     erase_player_1_cloud
    ldy     p1_fuel_offset
    lda     #$aa
    ldx     #3
.p1_restore_fuel_loop
    sta     p1_fuel_base,y
    cpy     #fuel_max_offset
    beq     .p1_full_fuel
    iny
    dex
    bne     .p1_restore_fuel_loop
    and     p1_fuel_pattern
    sta     p1_fuel_base,y
    jmp     .p1_update_fuel_offset
.p1_full_fuel
    lda     #$fc
    sta     p1_fuel_pattern
.p1_update_fuel_offset
    sty     p1_fuel_offset
    cpy     #fuel_warning_level + 1
    bmi     .no_p1_fairy_dust
    lda     #fuel_gauge_color
    sta     p1_fuel_color
.no_p1_fairy_dust
    dec     speed_up_frames         ; Check for cloud speed up.
    bne     .no_cloud_speed_up
    lda     #60                     ; Reset the frame count.
    sta     speed_up_frames
    dec     speed_up_timer          ; Check the main timer.
    bne     .no_cloud_speed_up
    lda     #speed_up_interval
    sta     speed_up_timer          ; Reset the timer.
    ldy     speed_index
    cpy     #max_speed_index        ; See if speed has topped out.
    beq     .no_cloud_speed_up
    iny
    sty     speed_index
    tya
    lsr                             ; Divide by two and use that for
    sta     star_shot_mode          ; the star shot mode.
    lda     cloud_rate_table,y
    sta     p0_cloud_rate
    sta     p1_cloud_rate
    lda     scroll_rate_table,y
    sta     p0_scroll_rate
    sta     p1_scroll_rate
    dec     current_cloud_color     ; Darken the cloud color every step.
    ldx     current_cloud_color
    lda     p0_attack_active        ; Update if an attack is not active.
    bne     .skip_p1_cloud_update
    stx     p1_playfield_0_color
.skip_p1_cloud_update
    lda     p1_attack_active
    bne     .skip_p0_cloud_update
    stx     p0_playfield_0_color
.skip_p0_cloud_update
    cpy     #2                      ; Darken the background on steps
    beq     .darken_bg              ; 2 and 6
    cpy     #6
    bne     .no_cloud_speed_up
.darken_bg
    lda     neutral_bg_color
    tay
    dey
    dey
    sty     neutral_bg_color
    cmp     p0_background_color
    bne     .no_p0_bg_update
    sty     p0_background_color
.no_p0_bg_update
    cmp     p1_background_color
    bne     .no_cloud_speed_up
    sty     p1_background_color
.no_cloud_speed_up

; Macro for handling star shot movement.
; {1} Address of the shot's data block.
; {2} The hpos storage for the hblank interrupts.
; {3} The bit pattern for the missile.
; {4} The missile's upper boundary.
; {5} the missile's lower boundary.
    mac move_star_shot
    lda     {1} + shot_hpos         ; See if the shot is active.
    bne     .shot_active
    jmp     .done
.shot_active
    clc
    lda     {1} + shot_hspeed       ; Apply the horizontal speed.
    adc     {1} + shot_hsubpixel
    bmi     .shot_left              ; On underflow, move left.
    cmp     #subpixel_limit
    bpl     .shot_right             ; Over the limit, move right.
    sta     {1} + shot_hsubpixel    ; Update the value.
    jmp     .check_vertical
.shot_left
    tay                             ; Save the subpixel for now.
    lda     {1} + shot_hpos         ; Check the screen edge.
    cmp     #left_bound
    bcs     .in_left_bounds
    jmp     .kill_shot
.in_left_bounds
    tya                             ; Get the subpixel back.
    adc     #subpixel_limit         ; Wrap the subpixel value.
    sta     {1} + shot_hsubpixel
    dec     {1} + shot_hpos         ; Update the stored positions.
    dec     {2}
    jmp     .check_vertical
.shot_right
    tay                             ; Save the subpixel for now.
    lda     {1} + shot_hpos         ; Check the screen edge.
    cmp     #right_bound
    bcc     .in_right_bounds
    jmp     .kill_shot
.in_right_bounds
    tya                             ; Get the subpixel back.
    sec
    sbc     #subpixel_limit         ; Wrap the subpixel value.
    sta     {1} + shot_hsubpixel
    inc     {1} + shot_hpos         ; Update the stored positions.
    inc     {2}
.check_vertical
    clc
    lda     {1} + shot_vspeed       ; Apply the vertical speed.
    adc     {1} + shot_vsubpixel
    bmi     .shot_up                ; On underflow, move up.
    cmp     #subpixel_limit
    bpl     .shot_down              ; Over 100, move down.
    sta     {1} + shot_vsubpixel    ; Update the value.
    jmp     .done
.shot_up
    tay                             ; Save the subpixel for now.
    lda     {1} + shot_vpos
    cmp     #{4} + 1                ; Check the screen boundary.
    bcs     .in_top_bounds
    jmp     .kill_shot
.in_top_bounds
    tya                             ; Get the subpixel back.
    adc     #subpixel_limit         ; Wrap the subpixel value.
    sta     {1} + shot_vsubpixel
    dec     {1} + shot_vpos         ; Update the position.
    ldy     {1} + shot_vpos         ; Update the graphics.
    lda     #{3}                    ; Load the missile pattern.
    ora     $1300,y                 ; Create a new row.
    sta     $1300,y
    lda     #~{3}                   ; Inverse pattern.
    and     $1302,y                 ; Blank the old row.
    sta     $1302,y
    jmp     .done
.shot_down
    tay                             ; Save the subpixel for now.
    lda     {1} + shot_vpos
    cmp     #{5}                    ; Check the screen boundary.
    bcc     .in_bottom_bounds
    jmp     .kill_shot
.in_bottom_bounds
    tya                             ; Get the subpixel back.
    sec
    sbc     #subpixel_limit         ; Wrap the value.
    sta     {1} + shot_vsubpixel
    ldy     {1} + shot_vpos         ; Update the graphics.
    lda     #~{3}                   ; Inverse pattern.
    and     $1300,y                 ; Blank the old row.
    sta     $1300,y
    lda     #{3}                    ; Load the missile pattern.
    ora     $1302,y                 ; Create a new row.
    sta     $1302,y
    inc     {1} + shot_vpos         ; Update the position.
    jmp     .done
.kill_shot
    ldy     {1} + shot_vpos         ; Erase the missile.
    ldx     #~{3}
    txa
    and     $1300,y
    sta     $1300,y
    txa
    and     $1301,y
    sta     $1301,y
    lda     #0                      ; Disable the shot.
    sta     {1} + shot_hpos
.done
    endm

; Handle star logic.  This includes spawning new stars,
; processing active stars, and destroying shot stars.
process_stars subroutine
    dec     star_timer              ; Check for a new spawn.
    beq     .spawn
    jmp     .spawn_done
.spawn
    lda     star_max_timer          ; Reset the timer.
    sta     star_timer
    lda     RANDOM                  ; Get a random index.
    and     #$3f                    ; Mask off the high bits.
    cmp     #40                     ; If it's 40+, subtract 40
    bmi     .x_location_good        ; to get a valid index.
    sec
    sbc     #40
.x_location_good
    ldx     #star_duration
    tay                             ; Save the index.
    lda     next_star               ; Find a hole for it.
    beq     .use_star_0
    stx     p0_star_1_ttl
    stx     p1_star_1_ttl
    sty     p0_star_1_index
    sty     p1_star_1_index
    jmp     .configure_draw
.use_star_0
    stx     p0_star_0_ttl
    stx     p1_star_0_ttl
    sty     p0_star_0_index
    sty     p1_star_0_index
.configure_draw
    sty     $fe                     ; Store the index for math.
    sec
    lda     #39
    sbc     $fe
    sta     $fc
    mva     #$11,$ff
    mva     #$1b,$fd
    ldy     #0
    ldx     #7
.draw_loop
    lda     star_sprite,x
    sta     ($fe),y
    sta     ($fc),y
    dex
    bmi     .spawn_done
    lda     next_star               ; Flip the next star bit.
    eor     #1
    sta     next_star
    jsr     next_playfield_row
    clc
    lda     $fc
    adc     #40
    sta     $fc
    lda     $fd 
    adc     #0
    sta     $fd
    jmp     .draw_loop
.spawn_done
    lda     #0                      ; Process player 0 stars.
    ldy     p0_star_0_index         ; Process the TTL timers.
    bmi     .p0_star_0_done
    mvx     #0,$ff
    ldx     p0_star_0_ttl
    dex
    stx     p0_star_0_ttl
    bne     .p0_star_0_alive
    dex                             ; Store -1 to disable the star.
    stx     p0_star_0_index
    inx
.p0_star_0_alive
    jsr     perform_star_logic
    lda     #0                      ; Restore the player number.
.p0_star_0_done
    ldy     p0_star_1_index
    bmi     .p0_star_1_done
    mvx     #1,$ff
    ldx     p0_star_1_ttl
    dex
    stx     p0_star_1_ttl
    bne     .p0_star_1_alive
    dex
    stx     p0_star_1_index
    inx
.p0_star_1_alive
    jsr     perform_star_logic
.p0_star_1_done
    lda     #1                      ; Repeat for player 1.
    ldy     p1_star_0_index
    bmi     .p1_star_0_done
    mvx     #0,$ff
    ldx     p1_star_0_ttl
    dex
    stx     p1_star_0_ttl
    bne     .p1_star_0_alive
    dex
    stx     p1_star_0_index
    inx
.p1_star_0_alive
    jsr     perform_star_logic
    lda     #1
.p1_star_0_done
    ldy     p1_star_1_index
    bmi     .p1_star_1_done
    mvx     #1,$ff
    ldx     p1_star_1_ttl
    dex
    stx     p1_star_1_ttl
    bne     .p1_star_1_alive
    dex
    stx     p1_star_1_index
    inx
.p1_star_1_alive
    jsr     perform_star_logic
.p1_star_1_done
    move_star_shot p0w0_shot,p0m3_hpos,$c0,p0_top_bound,p0_bottom_bound + 18
    move_star_shot p0w1_shot,p0m2_hpos,$30,p0_top_bound,p0_bottom_bound + 18
    move_star_shot p1w0_shot,p1m1_hpos,$0c,p1_top_bound,p1_bottom_bound + 18
    move_star_shot p1w1_shot,p1m0_hpos,$03,p1_top_bound,p1_bottom_bound + 18
    lda     p0_fairy_power          ; Strobe a full power gauge.
    cmp     #max_fairy_power
    bne     .no_p0_power_strobe
    ldy     p0_gauge_color
    iny
    cpy     #$20
    bne     .no_p0_power_strobe_flip
    ldy     #gauge_max_color
.no_p0_power_strobe_flip
    sty     p0_gauge_color
.no_p0_power_strobe
    lda     p1_fairy_power
    cmp     #max_fairy_power
    bne     .no_p1_power_strobe
    ldy     sCOLPM0
    iny
    cpy     #$20
    bne     .no_p1_power_strobe_flip
    ldy     #gauge_max_color
.no_p1_power_strobe_flip
    sty     sCOLPM0
    sty     sCOLPM1
.no_p1_power_strobe
    lda     p0_scroll_flag          ; Check the scrolling.
    bne     .p0_scroll_done         ; If not 0, still waiting for scroll.
    dec     p0_scroll_timer         ; Drop the timer.
    bne     .p0_scroll_done         ; Not time yet.
    lda     p0_scroll_speed         ; Request a scroll.
    sta     p0_scroll_flag
    sta     p0_scroll_target
.p0_scroll_done
    lda     p1_scroll_flag          ; Repeat for player 1.
    bne     .p1_scroll_done
    dec     p1_scroll_timer
    bne     .p1_scroll_done
    lda     p1_scroll_speed
    sta     p1_scroll_flag
    sta     p1_scroll_target
.p1_scroll_done
    jmp     game_loop

; Pause logic loop.
pause_loop subroutine
    jsr     wait_for_vb
    lda     last_key_pressed
    mvx     #$ff,last_key_pressed
    cmp     #$0d
    bne     .no_pause
    jmp     game_loop
.no_pause
    cmp     #$0e
    bne     pause_loop
    jsr     wait_for_vb
    jmp     start_title_screen

; Death animation processing loop.
death_loop subroutine
    ldx     #$ff                    ; Reset the stack, need to clear
    txs                             ; all subroutine calls.
    jsr     stop_all_sounds
    mwa     player_death_sound,$fe
    jsr     play_sound_1            ; Play the death sound.
    lda     p0_real_hpos            ; Ensure both players are on screen.
    sta     p0_hpos
    lda     p1_real_hpos
    sta     p1_hpos
    ldx     #8                      ; 8 steps in the death sequence.
    lda     dead_player
    beq     .kill_player_0
    lda     #0                      ; Remove the wings.
    sta     p1_real_wing_hpos
    lda     #$0e                    ; Set the dead player to white.
    sta     p1_color_1
    sta     p1_color_2
    sta     p1_color_3
    jmp     .loop
.kill_player_0
    lda     #0                      ; Remove the wings.
    sta     p0_real_wing_hpos
    lda     #$0e                    ; Set the dead player to white.
    sta     p0_color_1
    sta     p0_color_2
    sta     p0_color_3
.loop
    ldy     #8
    jsr     wait_for_y_frames
    dex
    beq     .remove_player
    lda     dead_player
    beq     .fade_player_0
    ldy     p1_color_1
    dey
    dey
    sty     p1_color_1
    sty     p1_color_2
    sty     p1_color_3
    jmp     .loop
.fade_player_0
    ldy     p0_color_1
    dey
    dey
    sty     p0_color_1
    sty     p0_color_2
    sty     p0_color_3
    jmp     .loop
.remove_player
    ldy     #0
    lda     dead_player
    beq     .remove_player_0
    sty     p1_hpos
    jmp     end_game
.remove_player_0
    sty     p0_hpos
    ; Fall through.

end_game subroutine
    ldy     #120
    jsr     wait_for_y_frames
    lda     game_mode
    cmp     #1
    beq     .one_player_end
    lda     #0
    sta     other_screen_active
    jsr     wait_for_vb
    jmp     start_character_select
.one_player_end
    lda     dead_player
    beq     .game_ending
    inc     schedule_progress
    lda     schedule_progress
    cmp     #8
    beq     .game_ending
    lda     #1
    sta     other_screen_active
    jsr     wait_for_vb
    jmp     start_character_select
.game_ending
    jsr     wait_for_vb
    jmp     start_game_over

; Handle the out of fuel animations.
fuel_out_loop subroutine
    mwa     fuel_out_sound,$fe
    jsr     play_sound_1
    lda     #57                     ; Fall 57 rows, this is guaranteed to put
    sta     $f0                     ; each player at the bottom.
.loop
    jsr     wait_for_vb
    lda     p0_fuel_offset          ; See if player 0 is dead.
    cmp     #-1
    bne     .done_p0
    lda     #0                      ; Move the wings off screen.
    sta     p0_real_wing_hpos
    sta     dead_player
    lda     p0_vpos                 ; Drop the player one row.
    cmp     #p0_bottom_bound
    beq     .done_p0                ; Stop at the bottom of the screen.
    ldy     #1
    inc     p0_vpos
    jsr     move_player_down
.done_p0
    lda     p1_fuel_offset          ; Repeat for player 1.
    cmp     #-1
    bne     .done_p1
    lda     #0
    sta     p1_real_wing_hpos
    lda     #1
    sta     dead_player
    lda     p1_vpos
    cmp     #p1_top_bound
    beq     .done_p1
    ldy     #1
    dec     p1_vpos
    jsr     move_player_up
.done_p1
    dec     $f0
    bne     .loop
    jmp     end_game

; Do the player shot sound if nothing else
; is using channel 1.
play_player_shot_sound subroutine
    lda     sound_pointer_1 + 1     ; If this is not zero, something
    bne     .sound_in_progress      ; is already playing.
    mwa     player_shot_sound,$fe
    jmp     play_sound_1
.sound_in_progress
    rts

; Drop player 0 fuel by one tick.
drop_player_0_fuel subroutine
    lda     p1_attack_active        ; No fuel drop while enemy
    bne     .no_warning             ; attack is active.
    ldy     p0_fuel_offset
    cpy     #-1
    beq     .done                   ; Do nothing on empty.
    lda     p0_fuel_pattern
    and     p0_fuel_base,y
    sta     p0_fuel_base,y
    lda     p0_fuel_pattern
    beq     .reset_pattern
    asl                             ; Shift the mask two bits.
    asl
    jmp     .store_pattern
.reset_pattern
    lda     #$fc
    dec     p0_fuel_offset
.store_pattern
    sta     p0_fuel_pattern
.done
    cpy     #fuel_warning_level     ; Start the warning color if low.
    bne     .no_warning
    lda     #$40
    sta     p0_fuel_color
.no_warning
    rts

; Drop player 1 fuel by one tick.
drop_player_1_fuel subroutine
    lda     p0_attack_active        ; No fuel drop while enemy
    bne     .no_warning             ; attack is active.
    ldy     p1_fuel_offset
    cpy     #-1
    beq     .done                   ; Do nothing on empty.
    lda     p1_fuel_pattern
    and     p1_fuel_base,y
    sta     p1_fuel_base,y
    lda     p1_fuel_pattern
    beq     .reset_pattern
    asl                             ; Shift the mask two bits.
    asl
    jmp     .store_pattern
.reset_pattern
    lda     #$fc
    dec     p1_fuel_offset
.store_pattern
    sta     p1_fuel_pattern
.done
    cpy     #fuel_warning_level     ; Start the warning color if low.
    bne     .no_warning
    lda     #$40
    sta     p1_fuel_color
.no_warning
    rts

; Handle all logic for stars.  Expects the star TTL in
; the X register, the star index in the Y register,
; the player number in the accumulator, and the star's
; ID number in $ff.
perform_star_logic subroutine
    sty     $f0                     ; Save the index.
    cpx     #0                      ; Check for star expiration.
    beq     .expire
    cpx     #star_duration - 10
    beq     .shoot
    rts                             ; No action to be taken.
.expire
    cmp     #0                      ; Select the side to erase.
    beq     .player_0_erase
    lda     #39                     ; Get the byte by subtracting the
    sec                             ; index from 39.
    sbc     $f0
    sta     $fe                     ; Store the low byte.
    mva     #$1b,$ff                ; Store the high byte.
    jmp     .erase_star
.player_0_erase
    sty     $fe                     ; Store the low byte.
    mva     #$11,$ff                ; Store the high byte.
.erase_star
    ldx     #7                      ; Erase 8 bytes.
    ldy     #0
.erase_loop
    tya
    sta     ($fe),y                 ; Erase a byte.
    jsr     next_playfield_row      ; Advance the address.
    dex
    bpl     .erase_loop
    rts
.shoot
    cmp     #0
    bne     player_1_star_shoot
    ; Fall through.

; Create a shot from a player 0 star.  Expects the star ID
; in $ff, this is called from perform_star_logic.
player_0_star_shoot subroutine
    lda     p0_real_hpos            ; Set the player location for the
    sta     $fe                     ; aim routine to use.
    lda     $ff                     ; Check the ID.
    beq     .star_0
    lda     p0_star_1_index         ; Get the index to calculate hpos.
    jsr     star_index_to_hpos
    sta     p0w1_shot + shot_hpos
    sta     $ff                     ; This is used by the aim routine.
    sta     p0m2_hpos
    lda     #p0_top_bound + 4
    sta     p0w1_shot + shot_vpos
    lda     #subpixel_limit / 2
    sta     p0w1_shot + shot_hsubpixel
    sta     p0w1_shot + shot_vsubpixel
    jsr     aim_star_shot
    sta     p0w1_shot + shot_hspeed
    lda     #25
    sta     p0w1_shot + shot_vspeed
    lda     #$30                    ; Load the graphics pattern.
    bne     .draw_shot              ; Always true.
.star_0
    lda     p0_star_0_index         ; Get the index to calculate hpos.
    jsr     star_index_to_hpos
    sta     p0w0_shot + shot_hpos
    sta     $ff                     ; This is used by the aim routine.
    sta     p0m3_hpos
    lda     #p0_top_bound + 4
    sta     p0w0_shot + shot_vpos
    lda     #subpixel_limit / 2
    sta     p0w0_shot + shot_hsubpixel
    sta     p0w0_shot + shot_vsubpixel
    jsr     aim_star_shot
    sta     p0w0_shot + shot_hspeed
    lda     #25
    sta     p0w0_shot + shot_vspeed
    lda     #$c0                    ; Load the graphics pattern.
.draw_shot
    pha                             ; Save the pattern.
    ora     $1300 + p0_top_bound + 4
    sta     $1300 + p0_top_bound + 4
    pla                             ; Get the pattern back.
    ora     $1301 + p0_top_bound + 4
    sta     $1301 + p0_top_bound + 4
    jmp     play_star_shoot_sound

; Just like the last routine, but for player 1.
player_1_star_shoot subroutine
    lda     p1_real_hpos            ; Set the player location for the
    sta     $fe                     ; aim routine to use.
    lda     $ff                     ; Check the ID.
    beq     .star_0
    lda     #39
    sec
    sbc     p1_star_1_index         ; Get the index to calculate hpos.
    jsr     star_index_to_hpos
    sta     p1w1_shot + shot_hpos
    sta     $ff                     ; This is used by the aim routine.
    sta     p1m0_hpos
    lda     #p1_bottom_bound + 15
    sta     p1w1_shot + shot_vpos
    lda     #subpixel_limit / 2
    sta     p1w1_shot + shot_hsubpixel
    sta     p1w1_shot + shot_vsubpixel
    jsr     aim_star_shot
    sta     p1w1_shot + shot_hspeed
    lda     #-25
    sta     p1w1_shot + shot_vspeed
    lda     #$03                    ; Load the graphics pattern.
    bne     .draw_shot              ; Always true.
.star_0
    lda     #39
    sec
    sbc     p1_star_0_index         ; Get the index to calculate hpos.
    jsr     star_index_to_hpos
    sta     p1w0_shot + shot_hpos
    sta     $ff                     ; This is used by the aim routine.
    sta     p1m1_hpos
    lda     #p1_bottom_bound + 15
    sta     p1w0_shot + shot_vpos
    lda     #subpixel_limit / 2
    sta     p1w0_shot + shot_hsubpixel
    sta     p1w0_shot + shot_vsubpixel
    jsr     aim_star_shot
    sta     p1w0_shot + shot_hspeed
    lda     #-25
    sta     p1w0_shot + shot_vspeed
    lda     #$0c                    ; Load the graphics pattern.
.draw_shot
    pha                             ; Save the pattern.
    ora     $1300 + p1_bottom_bound + 15
    sta     $1300 + p1_bottom_bound + 15
    pla                             ; Get the pattern back.
    ora     $1301 + p1_bottom_bound + 15
    sta     $1301 + p1_bottom_bound + 15
    ; Fall through.

; Play the star shot sound.
play_star_shoot_sound subroutine
    mwa     star_shoot_sound,$fe
    jsr     play_sound_1
    rts

; Convert the star index in the accumulator to its
; horizontal position.  Return in the accumulator.
star_index_to_hpos subroutine
    asl                             ; Multiply by 4.
    asl
    clc                             ; Offset from the boundary + 1 to
    adc     #left_bound + 1         ; center the shot on the firing star.
    rts

; Check a shot against stars.  Expects the shot hpos in
; the accumulator.  Returns indices of potential star
; hits in x and y.  A result of -2 is no hit, since -1
; is the index of an inactive star.
check_star_hits subroutine
    sec                             ; Subtract the leftmost hpos
    sbc     #left_bound             ; to match the logical star hpos.
    tay                             ; Save the value.
    lsr                             ; Divide by 4 to reach the first index.
    lsr
    tax                             ; Store it in x.
    tya                             ; Get the value back.
    and     #3                      ; If the smallest two bits are clear,
    beq     .no_second_hit          ; this is a "perfect" hit on one star.
    txa
    tay
    iny                             ; The shot overlaps the next star.
    rts
.no_second_hit
    ldy     #-2                     ; No overlap.
    rts

; Move a player sprite up.  Expects the base address
; of the sprite's current location in the accumulator, and the
; number of rows to move in y.
move_player_up subroutine
    sty     $ff                     ; Save the offset.
    tay                             ; Y is the source.
    sec
    sbc     $ff                     ; Find the target.
    tax                             ; X is the target.
    lda     #player_sprite_rows     ; Rows to move.
    sta     $fe
.copy_loop
    lda     $1500,y                 ; Transfer bytes.  P0 doesn't
    sta     $1500,x                 ; need to be copied, the wings
    lda     $1600,y                 ; have their own draw cycle.
    sta     $1600,x
    lda     $1700,y
    sta     $1700,x
    dec     $fe
    beq     .done_copy
    inx
    iny
    jmp     .copy_loop
.done_copy
    ldx     $ff                     ; Get the offset back.
    lda     #0
.erase_loop
    sta     $1400,y                 ; P0 does need erasure.
    sta     $1500,y
    sta     $1600,y
    sta     $1700,y
    dex
    beq     .done
    dey
    jmp     .erase_loop
.done
    rts

; Move a player sprite down.  Expects the same input as
; move_player_up.
move_player_down subroutine
    sty     $ff                     ; Save the offset.
    clc
    adc     #player_sprite_rows - 1 ; Find the source.
    tay                             ; Y is the source.
    adc     $ff                     ; Find the target.
    tax                             ; X is the target.
    lda     #player_sprite_rows     ; Rows to move.
    sta     $fe
.copy_loop
    lda     $1500,y                 ; Transfer bytes.  P0 doesn't
    sta     $1500,x                 ; need to be copied, the wings
    lda     $1600,y                 ; have their own draw cycle.
    sta     $1600,x
    lda     $1700,y
    sta     $1700,x
    dec     $fe
    beq     .done_copy
    dex
    dey
    jmp     .copy_loop
.done_copy
    ldx     $ff                     ; Get the offset back.
    lda     #0
.erase_loop
    sta     $1400,y                 ; P0 does need erasure.
    sta     $1500,y
    sta     $1600,y
    sta     $1700,y
    dex
    beq     .done
    iny
    jmp     .erase_loop
.done
    rts

; Check for a cloud hit.  Returns the index of the hit
; cloud in y, -1 if no hit was found.
find_p0_hit_cloud subroutine
    lda     p0_shot_vpos            ; Check for active shot.
    beq     .no_hit
    ldy     #7                      ; List index.
.loop
    lda     p0_cloud_hpos,y         ; -1 is inactive.
    cmp     #-1
    beq     .next
    sec
    sbc     p0_shot_hpos            ; If the hpos difference is less
    cmp     #4                      ; than 4 or greater than 248, the
    bcc     .h_hit                  ; shot is a hit.
    cmp     #248
    bcc     .next
.h_hit
    lda     p0_cloud_vpos,y         ; Check the vpos.
    sec
    sbc     p0_shot_vpos
    cmp     #9 + shot_speed         ; The range -2 .. 8 is a hit.
    bpl     .next                   ; The shot has already moved,
    cmp     #-2 + shot_speed        ; so offset.
    bpl     .hit
.next
    dey
    bpl     .loop
.no_hit
    ldy     #-1                     ; No hit.
.hit
    rts

; The same, but for player 1.
find_p1_hit_cloud subroutine
    lda     p1_shot_vpos            ; Check for active shot.
    beq     .no_hit
    ldy     #7                      ; List index.
.loop
    lda     p1_cloud_hpos,y         ; -1 is inactive.
    cmp     #-1
    beq     .next
    sec
    sbc     p1_shot_hpos
    cmp     #4
    bcc     .h_hit
    cmp     #248
    bcc     .next
.h_hit
    lda     p1_cloud_vpos,y         ; Check the vpos.
    sec
    sbc     p1_shot_vpos
    cmp     #-9 - shot_speed        ; The range -2 .. 8 is a hit.
    bmi     .next                   ; The shot has already moved,
    cmp     #2 - shot_speed         ; so offset.
    bmi     .hit
.next
    dey
    bpl     .loop
.no_hit
    ldy     #-1
.hit
    tya                             ; Set the negative flag for return.
    rts

; Erase and deactivate a player 0 cloud.  Expects the
; cloud index to be passed in y.
erase_player_0_cloud subroutine
    lda     p0_cloud_vpos,y         ; If this cloud was spawning,
    cmp     #p0_top_bound + 16      ; cancel it.
    bcs     .no_spawn_erase
    lda     #-1
    sta     p0_cloud_index
.no_spawn_erase
    lda     p0_cloud_low_byte,y
    sta     $fe
    lda     p0_cloud_high_byte,y
    beq     .null_address           ; Ignore if the address is null.
    sta     $ff
    tya
    pha                             ; Save the cloud index.
    ldy     #0                      ; Byte index.
    ldx     #8                      ; Row count.
.erase_loop
    lda     #0                      ; Blank the bytes.
    sta     ($fe),y
    iny
    sta     ($fe),y
    dex
    beq     .erase_done
    lda     $ff                     ; Check for wrap.
    cmp     #$31                    ; If < $3168, need to wrap.
    bne     .erase_update
    lda     $fe
    cmp     #$68
    bcs     .erase_update
    pla
    tay
    lda     p0_cloud_hpos,y         ; The byte offset is (hpos - left_bound) / 4.
    sec
    sbc     #left_bound
    lsr
    lsr
    clc
    adc     #$c8                    ; Add offset to $3fc8
    sta     $fe
    lda     #$3f
    sta     $ff                     ; This should never carry.
    tya
    pha                             ; Save the loop index.
    ldy     #0                      ; Restore the byte index.
    jmp     .erase_loop
.erase_update
    lda     $fe                     ; Update the address.
    sec
    sbc     #$28
    sta     $fe
    lda     $ff
    sbc     #0
    sta     $ff
    dey                             ; Restore the byte index.
    jmp     .erase_loop
.erase_done
    pla
    tay
.null_address
    lda     #-1
    sta     p0_cloud_hpos,y         ; Deactivate the cloud.
    rts

; The same, but for player 1.
erase_player_1_cloud subroutine
    lda     p1_cloud_vpos,y         ; If this cloud was spawning, cancel it.
    cmp     #p1_bottom_bound + #player_sprite_rows - 16
    bcc     .no_spawn_erase
    lda     #-1
    sta     p1_cloud_index
.no_spawn_erase
    lda     p1_cloud_low_byte,y
    sta     $fe
    lda     p1_cloud_high_byte,y
    beq     .null_address           ; Ignore if the address is null.
    sta     $ff
    tya
    pha                             ; Save the cloud index.
    ldy     #0                      ; Byte count.
    ldx     #8                      ; Row count.
.erase_loop
    lda     #0                      ; Blank the bytes.
    sta     ($fe),y
    iny
    sta     ($fe),y
    dex
    beq     .erase_done
    lda     $ff                     ; Check for wrap.
    cmp     #$2e                    ; If >= $2e88, need to wrap.
    bne     .erase_update
    lda     $fe
    cmp     #$88
    bcc     .erase_update
    pla
    tay
    lda     p1_cloud_hpos,y         ; The byte offset is (hpos - left_bound) / 4.
    sec
    sbc     #left_bound
    lsr
    lsr
    sta     $fe                     ; Add the offset to $2000.
    lda     #$20
    sta     $ff
    tya
    pha                             ; Save the byte index.
    ldy     #0
    jmp     .erase_loop
.erase_update
    lda     $fe                     ; Update the address.
    clc
    adc     #$28
    sta     $fe
    lda     $ff
    adc     #0
    sta     $ff
    dey                             ; Restore the byte index.
    jmp     .erase_loop
.erase_done
    pla
    tay
.null_address
    lda     #-1
    sta     p1_cloud_hpos,y         ; Deactivate the cloud.
    rts

; Erase all active player 0 clouds.  Used by the
; character attack routines to prep the playfield.
erase_all_player_0_clouds subroutine
    ldy     #7
.loop
    lda     p0_cloud_hpos,y
    cmp     #-1                     ; -1 is inactive.
    beq     .inactive
    jsr     erase_player_0_cloud
.inactive
    dey
    bne     .loop
    rts
    
; The same, but for player 1.
erase_all_player_1_clouds subroutine
    ldy     #7
.loop
    lda     p1_cloud_hpos,y
    cmp     #-1                     ; -1 is inactive.
    beq     .inactive
    jsr     erase_player_1_cloud
.inactive
    dey
    bne     .loop
    rts

; Reset the scroll address for player 0.  This is used
; to make special attacks more practical to implement.
; Probably should make sure to disable scrolling before
; calling this, just in case.
reset_player_0_scroll subroutine
    lda     #p0_scroll_base - #$800 + #3
    sta     p0_scroll_wrap
    mwa     p0_scroll_erase_start,p0_scroll_erase
    ldy     #p0_scroll_base - $800 + 6
    jsr     reset_player_scroll_common
    lda     #$4e
    sta     p0_scroll_base
    sta     p0_scroll_base + 3
    lda     #$40
    sta     p0_scroll_base + 1
    lda     #$68
    sta     p0_scroll_base + 4
    lda     #$31
    sta     p0_scroll_base + 2
    sta     p0_scroll_base + 5
    lda     #$8e
    sta     p0_scroll_base + 72
    rts

; The same, but for player 1.
reset_player_1_scroll subroutine
    mwa     $2aa0,p1_cloud_address
    lda     #p1_scroll_wrap_base - $800
    sta     p1_scroll_wrap
    ldy     #p1_scroll_base - $800 + 3
    jsr     reset_player_scroll_common
    lda     #$4e
    sta     p1_scroll_base
    lda     #0
    sta     p1_scroll_base + 1
    lda     #$20
    sta     p1_scroll_base + 2
    lda     #$ce
    sta     p1_scroll_wrap_base
    lda     #$a0
    sta     p1_scroll_wrap_base + 1
    lda     #$2a
    sta     p1_scroll_wrap_base + 2
    rts

; Common logic for both the player scroll resets.
; Writes out $0e display list for 67 bytes, starting
; at the display list offset in y.
reset_player_scroll_common subroutine
    ldx     #67                     ; Write 67 bytes.
    lda     #$0e                    ; Mode e.
.loop
    sta     $800,y
    dex
    beq     .done
    iny
    bne     .loop                   ; Always true.
.done
    rts

; Applies a change in fairy power to the player 0 gauge.
; Expects the change in the x register.
apply_p0_fairy_power subroutine
    lda     p0_fairy_power          ; Update the total.
    stx     $ff
    clc
    adc     $ff
    cmp     #max_fairy_power + 1    ; Check for overflow.
    bmi     .no_overflow
    lda     #max_fairy_power
.no_overflow
    tay
    sta     p0_fairy_power
    cmp     #minor_fairy_power      ; Set the gauge color.
    bmi     .power_low
    cmp     #max_fairy_power
    bne     .power_high
    lda     #gauge_max_color
    .byte   $2c
.power_high
    lda     #gauge_high_color
    .byte   $2c
.power_low
    lda     #gauge_low_color
.update_gauge
    sta     p0_gauge_color
    lda     gauge_table_p0,y        ; Get the gauge values.
    sta     $ff
    lda     gauge_table_p1,y
    tax
    ldy     #6
.draw_loop
    lda     $ff
    sta     $14d5,y
    txa
    sta     $15d5,y
    dey
    bne     .draw_loop
    rts

; Applies a change in fairy power to the player 1 gauge.
; Functions like the player 0 version.
apply_p1_fairy_power subroutine
    lda     p1_fairy_power
    stx     $ff
    clc
    adc     $ff
    cmp     #max_fairy_power + 1
    bmi     .no_overflow
    lda     #max_fairy_power
.no_overflow
    tay
    sta     p1_fairy_power
    cmp     #minor_fairy_power
    bmi     .power_low
    cmp     #max_fairy_power
    bne     .power_high
    lda     #gauge_max_color
    .byte   $2c
.power_high
    lda     #gauge_high_color
    .byte   $2c
.power_low
    lda     #gauge_low_color
.update_gauge
    sta     sCOLPM0
    sta     sCOLPM1
    lda     gauge_table_p0,y
    sta     $ff
    lda     gauge_table_p1,y
    tax
    ldy     #6
.draw_loop
    lda     $ff
    sta     $1423,y
    txa
    sta     $1523,y
    dey
    bne     .draw_loop
    rts

; Given a star hposition in $ff and a player
; hposition in $fe, returns the hspeed for a
; star shot.  Value is placed in the accumulator.
aim_star_shot subroutine
    ldx     star_shot_mode
    lda     star_hspeed_table_low,x ; Prep the speed table for
    sta     $f0                     ; this mode.
    lda     star_hspeed_table_high,x
    sta     $f1
    ldy     #0                      ; Assume positive.
    lda     $fe                     ; Figure out the direction.
    sec
    sbc     $ff
    bcs     .check_distance
.negative_speed
    iny                             ; Sign flag to 1.
    lda     $ff                     ; Get the distance from the
    sec                             ; other direction.
    sbc     $fe
.check_distance
    sty     $fd                     ; Stash the sign flag.
    cmp     #10
    bcs     .check_level_2
    ldy     #0
    beq     .apply_sign             ; Always true.
.check_level_2
    cmp     #40
    bcs     .check_level_3
    ldy     #1
    bne     .apply_sign             ; Always true.
.check_level_3
    cmp     #80
    bcs     .check_level_4
    ldy     #2
    bne     .apply_sign             ; Always true.
.check_level_4
    cmp     #130
    bcs     .level_5
    ldy     #3
    .byte   $2c
.level_5
    ldy     #4
.apply_sign
    lda     ($f0),y                 ; Get the speed value.
    ldx     $fd                     ; Check the sign.
    beq     .positive_result
    eor     #$ff                    ; Flip the sign to negative.
    clc
    adc     #1
.positive_result
    rts

; Applies damage to player 0.  Ignores the damage
; if the player is currently in hit-invincibility.
; Jumps to death loop if the player is out of health.
damage_player_0 subroutine
    lda     p0_hit_invinc           ; Check the hit invincibility.
    beq     .proceed
    rts                             ; No hit, still alive.
damage_player_0_force               ; Alternate call with no invincibility
.proceed                            ; frame check.
    lda     p0_health_mask          ; Mask out a dot.
    and     $13d6
    ldy     #6                      ; Row counter.
.clear_loop
    sta     $13d5,y
    dey
    bne     .clear_loop
    cmp     #0
    bne     .player_alive
    sta     dead_player
    jmp     death_loop
.player_alive
    lsr                             ; Shift the mask over 2 bits.
    lsr
    sta     p0_health_mask
    mwa     player_damage_sound,$fe
    jsr     play_sound_2            ; Play the hit sound.
    lda     #hit_invinc_time        ; Set the hit timer.
    sta     p0_hit_invinc
    rts

; The same as above, but for player 1.
damage_player_1 subroutine
    lda     p1_hit_invinc           ; Check the hit invincibility.
    beq     .proceed
    rts                             ; No hit, still alive.
damage_player_1_force               ; Alternate call with no invincibility
.proceed                            ; frame check.
    lda     p1_health_mask          ; Mask out a dot.
    and     $1324
    ldy     #6                      ; Row counter.
.clear_loop
    sta     $1323,y
    dey
    bne     .clear_loop
    cmp     #0
    bne     .player_alive
    lda     #1
    sta     dead_player
    jmp     death_loop
.player_alive
    asl                             ; Shift the mask over two bits.
    asl
    sta     p1_health_mask
    mwa     player_damage_sound,$fe
    jsr     play_sound_2            ; Play the hit sound.
    lda     #hit_invinc_time        ; Set the hit timer.
    sta     p1_hit_invinc
    rts

; Figure out what type of falling object to spawn.
; Expects the current cloud count in the accumulator
; and the player number in y.
; Returns the object to spawn in x and the new cloud
; count in the accumulator.
determine_object_spawn subroutine
    pha                             ; Save the cloud count.
    lda     p0_lightning_flag,y     ; Check the attack flag.
    beq     .no_lightning_attack
    lda     #0                      ; Clear the flag.
    sta     p0_lightning_flag,y
    ldx     #spawn_lightning
    pla                             ; Get the cloud count.
    rts
.no_lightning_attack
    pla                             ; Get the cloud count.
    cmp     #fairy_dust_trigger     ; Check for fairy dust.
    bcc     .no_fairy_dust
    sec
    sbc     #fairy_dust_trigger     ; Adjust the value.
    ldx     #spawn_fairy_dust
    rts
.no_fairy_dust
    pha                             ; Save the cloud count.
    cpy     #0                      ; Get the appropriate random number.
    beq     .player_0_random
    jsr     get_player_1_random
    jmp     .random_done
.player_0_random
    jsr     get_player_0_random
.random_done
    and     #$0f                    ; Mask down to 0-15.
    beq     .spawn_lightning        ; 1/16 chance of lightning.
.spawn_cloud
    ldx     #spawn_cloud
    pla                             ; Get the cloud count back.
    rts
.spawn_lightning
    ldx     #spawn_lightning
    pla                             ; Get the cloud count back.
    rts

; Copies a player sprite image and properly
; rotates it 180 degrees.  This is very slow, but
; it only runs during game setup so that's OK.
; Expects the frame to copy in $fc-$fd and the
; target location in $fe-$ff.
copy_sprite_180 subroutine
    ldy     #0                      ; Target index.
    sty     $fb                     ; Save it.
    ldy     #player_sprite_rows - 1 ; Source index.
    sty     $fa                     ; Save it.
.byte_loop
    ldy     $fa                     ; Grab the source index.
    lda     ($fc),y                 ; Grab a byte.
    ldx     #8                      ; Bit counter.
    ldy     $fb                     ; Grab the target index.
.byte_reverse_loop
    asl                             ; Shift a bit into carry.
    php                             ; Save it.
    dex                             ; Check for completion.
    bne     .byte_reverse_loop
    ldx     #8                      ; Bit counter.
.byte_build_loop
    plp                             ; Get a bit back.
    rol                             ; Rotate it in.
    dex                             ; Check for completion.
    bne     .byte_build_loop
    sta     ($fe),y                 ; Write the byte
    inc     $fb                     ; Update the target index.
    dec     $fa                     ; Check for image completion.
    bpl     .byte_loop
    rts

; Get the next random number for player 0.
; Result is in the accumulator.
get_player_0_random subroutine
    lda     p0_random
    asl
    bcc     .random_done
    eor     #$1d
.random_done
    sta     p0_random
    rts

; Same for player 1.
get_player_1_random subroutine
    lda     p1_random
    asl
    bcc     .random_done
    eor     #$1d
.random_done
    sta     p1_random
    rts

; End an attack made by player 0.
end_player_0_attack subroutine
    lda     #0
    sta     p1_scroll_flag
    sta     p0_attack_active
    lda     p1_scroll_rate
    sta     p1_scroll_timer
    lda     current_cloud_color
    sta     p1_playfield_0_color
    lda     #lightning_color
    sta     p1_playfield_1_color
    lda     #fairy_dust_color
    sta     p1_playfield_2_color
    jmp     p0_process_return

; End an attack made by player 1.
end_player_1_attack subroutine
    lda     #0
    sta     p0_scroll_flag
    sta     p1_attack_active
    lda     p0_scroll_rate
    sta     p0_scroll_timer
    lda     current_cloud_color
    sta     p0_playfield_0_color
    lda     #lightning_color
    sta     p0_playfield_1_color
    lda     #fairy_dust_color
    sta     p0_playfield_2_color
    jmp     p1_process_return

; Set all the bytes in a playfield row to a
; specific value.  The row address is passed
; in $fe-$ff and the value is in the accumulator.
set_playfield_row subroutine
    ldy     #39                     ; Erase 40 bytes.
.loop
    sta     ($fe),y
    dey
    bpl     .loop
    rts

; Add 40 to an address stored in $fe-$ff.  This
; needs to be done all over the place.
next_playfield_row subroutine
    clc
    lda     $fe
    adc     #40
    sta     $fe
    lda     $ff
    adc     #0
    sta     $ff
    rts

; Common code that most characters use when starting
; their special attacks.  One version for each player.
; Expects the cost of the attack in x.
general_player_0_attack_start subroutine
    jsr     apply_p0_fairy_power
    ldy     #-2
    sty     p1_scroll_flag          ; Stop scrolling
    sty     p0_attack_active
    jsr     erase_all_player_1_clouds
    jsr     reset_player_1_scroll
    lda     #2
    sta     p1_cloud_timer          ; Suppress cloud spawns.
    rts

; The same, for the other player.
general_player_1_attack_start subroutine
    jsr     apply_p1_fairy_power
    ldy     #-2
    sty     p0_scroll_flag          ; Stop scrolling
    sty     p1_attack_active
    jsr     erase_all_player_0_clouds
    jsr     reset_player_0_scroll
    lda     #2
    sta     p0_cloud_timer          ; Suppress cloud spawns.
    rts

game_vblank subroutine
    jsr     process_sounds
    lda     $f0
    pha
    lda     $f1
    pha
    lda     $fe                     ; Preserve $f0, $f1, $fe and $ff.
    pha
    lda     $ff
    pha
    lda     #0
    sta     ATRACT
    ldy     key_debounce
    beq     .no_debounce
    dec     key_debounce
.no_debounce
    sta     VDSLST                  ; Reset the hblank interrupts.
    lda     #$ac
    sta     VDSLST + 1
    lda     P1PF                    ; Save the collision data for the
    ora     P2PF                    ; lower half of the screen.
    ora     P3PF
    sta     pf_low
    lda     M2PL
    ora     M3PL
    sta     mpl_low
    sta     HITCLR
    mva     #55,HPOSP0              ; Set the player locations for
    sta     HPOSP2                  ; upper power gauge.
    mva     #63,HPOSP1
    lda     #1
    sta     SIZEP2
    lda     #p1_health_hpos         ; Set the missile positions for
    sta     HPOSM3                  ; the health indicators.
    lda     #p1_health_hpos + 4
    sta     HPOSM2
    lda     #p1_health_hpos + 8
    sta     HPOSM1
    lda     #p1_health_hpos + 12
    sta     HPOSM0
    lda     wing_blink              ; Handle wing blink.
    eor     #1
    sta     wing_blink
    beq     .wings_on
    lda     #0
    sta     p0_wing_hpos
    sta     p1_wing_hpos
    jmp     .wing_loop_done
.wings_on
    lda     p0_real_wing_hpos
    sta     p0_wing_hpos
    lda     p1_real_wing_hpos
    sta     p1_wing_hpos
    lda     wing_frame
    eor     #1
    sta     wing_frame
    beq     .frame_1
    mwa     wing_sprite_2,$fe
    jmp     .copy_wing_data
.frame_1
    mwa     wing_sprite_1,$fe
.copy_wing_data
    ldx     p1_vpos
    lda     p0_vpos
    clc
    adc     #player_sprite_rows - 1
    tay
    lda     #player_sprite_rows - 1
    sta     $f0
    sty     $f1
.wing_loop
    ldy     $f0
    lda     ($fe),y
    ldy     $f1
    sta     $1400,y
    sta     $1400,x
    dec     $f0
    bmi     .wing_loop_done
    dec     $f1
    inx
    jmp     .wing_loop
.wing_loop_done
    lda     p0_hit_invinc           ; Check for hit blink.
    beq     .p0_hit_blink_show
    lda     p0_blink_flag           ; Check the state.
    eor     #1
    sta     p0_blink_flag
    beq     .p0_hit_blink_show      ; Show the player on even.
    lda     #0                      ; Blank the player.
    sta     p0_hpos
    jmp     .p0_hit_blink_done
.p0_hit_blink_show
    lda     p0_real_hpos            ; Use the real hpos.
    sta     p0_hpos
.p0_hit_blink_done
    lda     p1_hit_invinc           ; Check for hit blink.
    beq     .p1_hit_blink_show
    lda     p1_blink_flag           ; Check the state.
    eor     #1
    sta     p1_blink_flag
    beq     .p1_hit_blink_show      ; Show the player on even.
    lda     #0                      ; Blank the player.
    sta     p1_hpos
    jmp     .p1_hit_blink_done
.p1_hit_blink_show
    lda     p1_real_hpos            ; Use the real hpos.
    sta     p1_hpos
.p1_hit_blink_done
    ldy     p0_scroll_flag          ; Perform scrolling if needed.
    beq     .skip_p0_scroll
    bpl     .do_p0_scroll
.skip_p0_scroll
    jmp     .p0_scroll_done
.do_p0_scroll
    dey                             ; Decrement the flag.
    bne     .no_p0_flag_reset       ; On 0, set the flag to -1
    dey                             ; to indicate completion.
.no_p0_flag_reset
    sty     p0_scroll_flag          ; Update the flag.
    lda     p0_scroll_base + 1      ; See if the scroll zone is at
    cmp     #$40                    ; the upper boundary.
    bne     .p0_scroll_check_middle_zone
    lda     p0_scroll_base + 2
    cmp     #$31
    bne     .p0_scroll_check_middle_zone
    lda     #$c8                    ; Wrap the start line to the end
    sta     p0_scroll_base + 1      ; of the scroll zone.
    lda     #$3f
    sta     p0_scroll_base + 2
    lda     #$40                    ; Set the loop row to $3140.  The
    sta     p0_scroll_base + 4      ; $31 byte is already there.
    jmp     .p0_update_scroll_erase
.p0_scroll_check_middle_zone
    lda     p0_scroll_base + 2      ; If the boundary is > $3550, the
    cmp     #$35                    ; boundary needs to move back.
    beq     .p0_scroll_middle_check_low_byte
    bcs     .p0_scroll_handle_middle
    jmp     .p0_scroll_handle_no_wrap
.p0_scroll_middle_check_low_byte
    lda     p0_scroll_base + 1
    cmp     #$51
    bcc     .p0_scroll_handle_no_wrap
.p0_scroll_handle_middle
    lda     p0_scroll_base + 1
    sec                             ; Subtract $28 from the current
    sbc     #$28                    ; boundary.
    sta     p0_scroll_base + 1
    lda     p0_scroll_base + 2
    sbc     #0
    sta     p0_scroll_base + 2
    lda     #$0e                    ; Clear the old wrap point.
    ldy     p0_scroll_wrap
    sta     $800,y
    lda     #$4e                    ; Create a new wrap point.
    cpy     #197
    bne     .no_interrupt
    ora     #$80
.no_interrupt
    sta     $801,y
    lda     #$40
    sta     $802,y
    lda     #$31
    sta     $803,y
    inc     p0_scroll_wrap          ; Update the wrap offset.
    jmp     .p0_update_scroll_erase
.p0_scroll_handle_no_wrap
    ldy     p0_scroll_wrap          ; Clear the old wrap point.
    lda     #$0e
    sta     $800,y
    sta     $801,y
    lda     #$8e
    sta     $802,y
    ldy     #<p0_scroll_base + 3
    sty     p0_scroll_wrap
    lda     #$4e                    ; Copy the old start point into
    sta     p0_scroll_base + 3      ; the new wrap point.
    lda     p0_scroll_base + 2
    sta     p0_scroll_base + 5
    lda     p0_scroll_base + 1
    sta     p0_scroll_base + 4
    sec                             ; Subtract $28 from the start line.
    sbc     #$28
    sta     p0_scroll_base + 1
    lda     p0_scroll_base + 2
    sbc     #0
    sta     p0_scroll_base + 2
.p0_update_scroll_erase
    lda     p0_scroll_erase         ; If the erase line is at $3140,
    cmp     #$40                    ; loop it to $3fc8.
    bne     .p0_move_erase_line
    lda     p0_scroll_erase + 1
    cmp     #$31
    bne     .p0_move_erase_line
    mwa     $3fc8,p0_scroll_erase
    jmp     .p0_check_cloud_spawn
.p0_move_erase_line
    sec
    lda     p0_scroll_erase         ; Subtract $28 from the erase line.
    sbc     #$28
    sta     p0_scroll_erase
    lda     p0_scroll_erase + 1
    sbc     #0
    sta     p0_scroll_erase + 1
.p0_check_cloud_spawn
    ldy     p0_cloud_index          ; Check the index.
    bmi     .p0_scroll_done         ; No spawn on -1.
    ldx     p0_cloud_offset         ; Get the offset into the image.
    lda     p0_scroll_base + 1      ; Get the row address.
    sta     $fe
    lda     p0_scroll_base + 2
    sta     $ff
    lda     p0_cloud_spawn          ; Determine what to spawn.
    beq     .p0_spawn_cloud
    cmp     #spawn_fairy_dust
    bne     .p0_spawn_lightning
    lda     fairy_dust_sprite,x     ; Get the first byte.
    sta     ($fe),y                 ; Write it.
    iny
    lda     fairy_dust_sprite + 1,x ; Get the next byte.
    sta     ($fe),y                 ; Write it.
    jmp     .p0_spawn_draw_done
.p0_spawn_lightning
    lda     lightning_sprite,x      ; Get the first byte.
    sta     ($fe),y                 ; Write it.
    iny
    lda     lightning_sprite + 1,x  ; Get the next byte.
    sta     ($fe),y                 ; Write it.
    jmp     .p0_spawn_draw_done
.p0_spawn_cloud
    lda     cloud_sprite,x          ; Get the first byte.
    sta     ($fe),y                 ; Write it.
    lda     cloud_sprite + 1,x      ; Get the next byte.
    iny
    sta     ($fe),y                 ; Write it.
.p0_spawn_draw_done
    ldx     p0_cloud_offset         ; If this is the first row, store
    cpx     #14                     ; the address in the cloud record.
    bne     .p0_skip_cloud_address_record
    ldx     p0_next_cloud
    dey
    tya                             ; Store the base byte for later
    clc                             ; erasure of the cloud.
    adc     $fe
    sta     p0_cloud_low_byte,x
    lda     $ff
    adc     #0
    sta     p0_cloud_high_byte,x
    lda     p0_cloud_spawn          ; If this is lightning, start the
    cmp     #spawn_lightning        ; background effect.
    bne     .p0_skip_cloud_address_record
    mwa     lightning_sound,$fe
    jsr     play_sound_4
    lda     #lightning_effect_time
    sta     p0_bg_effect_timer
    lda     #$8e
    sta     p0_background_color
.p0_skip_cloud_address_record
    dec     p0_cloud_offset         ; Update the index.
    bmi     .end_p0_cloud_spawn
    dec     p0_cloud_offset
    jmp     .p0_scroll_done
.end_p0_cloud_spawn
    lda     #-1                     ; Clear the index.
    sta     p0_cloud_index
.p0_scroll_done
    ldy     p1_scroll_flag
    beq     .skip_p1_scroll
    bpl     .do_p1_scroll
.skip_p1_scroll
    jmp     .p1_scroll_done
.do_p1_scroll
    dey                             ; Decrement the flag.
    bne     .no_p1_flag_reset       ; On 0, set the flag to -1
    dey                             ; to indicate completion.
.no_p1_flag_reset
    sty     p1_scroll_flag          ; Update the flag.
    lda     p1_scroll_base + 2      ; If the boundary is less than $23e8,
    cmp     #$23                    ; shift the window down by $28.
    bcc     .p1_scroll_handle_upper_zone
    bne     .p1_scroll_check_boundary
    lda     p1_scroll_base + 1
    cmp     #$e8
    bcc     .p1_scroll_handle_upper_zone
    bne     .p1_scroll_check_boundary
    lda     p1_scroll_base + 1      ; The boundary is $23e8, so start
    clc                             ; wrapping the field.
    adc     #$28
    sta     p1_scroll_base + 1
    lda     #0
    sta     p1_cloud_address
    sta     p1_scroll_wrap_base + 1
    adc     p1_scroll_base + 2
    sta     p1_scroll_base + 2
    lda     #$20
    sta     p1_scroll_wrap_base + 2 ; Set the wrap to $2000.
    sta     p1_cloud_address + 1
    jmp     .p1_check_cloud_spawn
.p1_scroll_handle_upper_zone
    lda     p1_scroll_base + 1      ; Add $28 to the boundary and the
    clc                             ; wrap point.
    adc     #$28
    sta     p1_scroll_base + 1
    lda     p1_scroll_base + 2
    adc     #0
    sta     p1_scroll_base + 2
    lda     p1_scroll_wrap_base + 1
    clc
    adc     #$28
    sta     p1_scroll_wrap_base + 1
    sta     p1_cloud_address
    lda     p1_scroll_wrap_base + 2
    adc     #0
    sta     p1_scroll_wrap_base + 2
    sta     p1_cloud_address + 1
    jmp     .p1_check_cloud_spawn
.p1_scroll_check_boundary
    lda     p1_scroll_base + 3      ; If the wrap has reached the top,
    cmp     #$4e                    ; reset the scroll.
    bne     .p1_scroll_boundary
    lda     #0                      ; Reset the boundary to $2000.
    sta     p1_scroll_base + 1
    lda     #$20
    sta     p1_scroll_base + 2
    lda     #$0e                    ; Clear the old wrap point.
    sta     p1_scroll_base + 3
    sta     p1_scroll_base + 4
    sta     p1_scroll_base + 5
    lda     #p1_scroll_wrap_base - $800
    sta     p1_scroll_wrap
    lda     #$ce                    ; Reset the wrap point.
    sta     p1_scroll_wrap_base
    lda     #$a0
    sta     p1_scroll_wrap_base + 1
    sta     p1_cloud_address
    lda     #$2a
    sta     p1_scroll_wrap_base + 2
    sta     p1_cloud_address + 1
    jmp     .p1_check_cloud_spawn
.p1_scroll_boundary
    lda     p1_scroll_base + 1      ; Add $28 to the current boundary.
    clc
    adc     #$28
    sta     p1_scroll_base + 1
    lda     p1_scroll_base + 2
    adc     #0
    sta     p1_scroll_base + 2
    ldy     p1_scroll_wrap          ; Move the wrap back one row.
    cpy     #p1_scroll_wrap_base -$800
    beq     .p1_first_scroll        ; On first scroll, preserve the interrupt.
    lda     #$0e
    jmp     .p1_update_scroll
.p1_first_scroll
    lda     #$8e
.p1_update_scroll
    dey
    sta     $803,y
    lda     #$4e
    sta     $800,y
    lda     #0
    sta     $801,y
    lda     #$20
    sta     $802,y
    sty     p1_scroll_wrap
    lda     p1_cloud_address        ; Update the cloud spawn line.
    clc
    adc     #$28
    sta     p1_cloud_address
    lda     p1_cloud_address + 1
    adc     #0
    sta     p1_cloud_address + 1
.p1_check_cloud_spawn
    ldy     p1_cloud_index          ; Check the index.
    bmi     .p1_scroll_done         ; No spawn on -1.
    lda     #38                     ; Invert the index.
    sec
    sbc     p1_cloud_index
    tay
    ldx     p1_cloud_offset         ; Get the offset into the image.
    lda     p1_cloud_address        ; Use the recorded line address.
    sta     $fe
    lda     p1_cloud_address + 1
    sta     $ff
    lda     p1_cloud_spawn          ; Determine what to spawn.
    beq     .p1_spawn_cloud
    cmp     #spawn_fairy_dust
    bne     .p1_spawn_lightning
    lda     fairy_dust_sprite,x     ; Get the first byte.
    sta     ($fe),y                 ; Write it.
    iny
    lda     fairy_dust_sprite + 1,x ; Get the next byte.
    sta     ($fe),y                 ; Write it.
    jmp     .p1_spawn_draw_done
.p1_spawn_lightning 
    lda     lightning_sprite,x      ; Get the first byte.
    sta     ($fe),y                 ; Write it.
    iny
    lda     lightning_sprite + 1,x  ; Get the next byte.
    sta     ($fe),y                 ; Write it.
    jmp     .p1_spawn_draw_done
.p1_spawn_cloud
    lda     cloud_sprite,x          ; Get the first byte.
    sta     ($fe),y                 ; Write it.
    lda     cloud_sprite + 1,x      ; Get the next byte.
    iny
    sta     ($fe),y                 ; Write it.
.p1_spawn_draw_done
    ldx     p1_cloud_offset         ; If this is the first row, store
    cpx     #14                     ; the address in the cloud record.
    bne     .p1_skip_cloud_address_record
    ldx     p1_next_cloud
    dey
    tya
    clc
    adc     $fe                     ; Store the base byte for later
    sta     p1_cloud_low_byte,x     ; erasure of the cloud.
    lda     $ff
    adc     #0
    sta     p1_cloud_high_byte,x
    lda     p1_cloud_spawn          ; If this is lightning, start the
    cmp     #spawn_lightning        ; background effect.
    bne     .p1_skip_cloud_address_record
    mwa     lightning_sound,$fe
    jsr     play_sound_3
    lda     #lightning_effect_time
    sta     p1_bg_effect_timer
    lda     #$8e
    sta     p1_background_color
.p1_skip_cloud_address_record
    dec     p1_cloud_offset         ; Update the index.
    bmi     .end_p1_cloud_spawn
    dec     p1_cloud_offset
    jmp     .p1_scroll_done
.end_p1_cloud_spawn
    lda     #-1                     ; Clear the index.
    sta     p1_cloud_index
.p1_scroll_done
    pla                             ; Restore $f0, $f1, $fe and $ff.
    sta     $ff
    pla
    sta     $fe
    pla
    sta     $f1
    pla
    sta     $f0
    jmp     ENDINT

