; This file is part of Magical Fairy Force.

; Magical Fairy Force is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; Magical Fairy Force is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with Magical Fairy Force.  If not, see <http://www.gnu.org/licenses/>.

; Copyright 2020 Average Software.

; Single player game over screen

start_game_over subroutine
    lda     #<null_display_list
    sta     sDLISTL
    sta     DLISTL
    lda     #>null_display_list
    sta     sDLISTH
    sta     DLISTH
    mwa     ENDINT,VVBLKD           ; Shut down the vblank interrupt.
    jsr     create_text_display_list
    lda     #0
    sta     sDLISTL                 ; Set up the display list.
    sta     DLISTL
    lda     #$8
    sta     sDLISTH
    sta     DLISTH
    lda     #$ff
    sta     sCOLOR1
    sta     COLPF1
    lda     #$0f
    sta     sCOLOR0
    sta     COLPF0
    lda     #0
    sta     sCOLBK                  ; Black background.
    sta     COLBK
    sta     sCOLOR2
    sta     COLPF2
    lda     schedule_progress
    cmp     #8
    beq     .show_ending
    mwa     game_over_text,$fc
    mwa     $21c7,$fe
    jsr     copy_text_full
    mwa     continue_text,$fc
    mwa     $2210,$fe
    jsr     copy_text_full
    mwa     give_up_text,$fc
    mwa     $2260,$fe
    jsr     copy_text_full
    jmp     .text_ready
.show_ending
    ldy     p0_character
    lda     ending_data_low,y
    sta     $fc
    lda     ending_data_high,y
    sta     $fd
    ldy     #0
    lda     ($fc),y                 ; Get the line count.
    sta     $fa
    lda     #$f0                    ; Start from $20f0.
    sta     $fe
    lda     #$20
    sta     $ff
    inc     $fc                     ; Move to the first line.
    bne     .ending_loop
    inc     $fd
.ending_loop
    dec     $fa
    bmi     .text_ready
    jsr     copy_text_full
    iny                             ; Y is the offset to the null.
    tya
    clc
    adc     $fc
    sta     $fc
    lda     $fd
    adc     #0
    sta     $fd
    lda     $fe
    clc
    adc     #40
    sta     $fe
    lda     $ff
    adc     #0
    sta     $ff
    bne     .ending_loop            ; Always true.
.text_ready
    lda     #0
    sta     sDLISTL
    lda     #$8
    sta     sDLISTH
    mva     #4,CONSOL               ; Activate player 1 controller.
    mwa     title_vblank,VVBLKD     ; Re-use the title screen vblank.
    mva     #$ff,last_key_pressed
    lda     #0                      ; Move players and missiles off screen.
    ldy     #7
.pm_clear_loop
    sta     HPOSP0,y
    dey
    bpl     .pm_clear_loop
    ; Fall through to the game over loop.

game_over_loop subroutine
    jsr     wait_for_vb
    lda     last_key_pressed
    bmi     game_over_loop
    cmp     #$0e
    beq     .reset
    cmp     #$0c
    beq     .continue
    lda     #$ff
    sta     last_key_pressed
    bmi     game_over_loop          ; Always true.
.reset
    jsr     wait_for_vb
    jmp     start_title_screen
.continue
    lda     schedule_progress
    cmp     #8
    beq     .reset
    lda     #1
    sta     other_screen_active
    jsr     wait_for_vb
    jmp     start_character_select

