; This file is part of Magical Fairy Force.

; Magical Fairy Force is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; Magical Fairy Force is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with Magical Fairy Force.  If not, see <http://www.gnu.org/licenses/>.

; Copyright 2020 Average Software.

; Hardware constants

; Page 0 stuff.
sIRQEN  equ     $00
RCLKHI  equ     $01
RCLKLO  equ     $02
ATRACT  equ     $04
sDLISTL equ     $05
sDLISTH equ     $06
sDMACTL equ     $07
sCOLPM0 equ     $08
sCOLPM1 equ     $09
sCOLPM2 equ     $0a
sCOLPM3 equ     $0b
sCOLOR0 equ     $0c
sCOLOR1 equ     $0d
sCOLOR2 equ     $0e
sCOLOR3 equ     $0f
sCOLBK  equ     $10
sPOT0   equ     $11
sPOT1   equ     $12
sPOT2   equ     $13
sPOT3   equ     $14
sPOT4   equ     $15
sPOT5   equ     $16
sPOT6   equ     $17
sPOT7   equ     $18

; Page 2 vectors.
VIMIRQ  equ     $200
VVBLKI  equ     $202
VVBLKD  equ     $204
VDSLST  equ     $206
VKYBDI  equ     $208
VKYBDF  equ     $20a

; GTIA registers.
HPOSP0  equ     $c000
M0PF    equ     $c000
HPOSP1  equ     $c001
M1PF    equ     $c001
HPOSP2  equ     $c002
M2PF    equ     $c002
HPOSP3  equ     $c003
M3PF    equ     $c003
HPOSM0  equ     $c004
P0PF    equ     $c004
HPOSM1  equ     $c005
P1PF    equ     $c005
HPOSM2  equ     $c006
P2PF    equ     $c006
HPOSM3  equ     $c007
P3PF    equ     $c007
SIZEP0  equ     $c008
M0PL    equ     $c008
SIZEP1  equ     $c009
M1PL    equ     $c009
SIZEP2  equ     $c00a
M2PL    equ     $c00a
SIZEP3  equ     $c00b
M3PL    equ     $c00b
SIZEM   equ     $c00c
P0PL    equ     $c00c
P1PL    equ     $c00d
P2PL    equ     $c00e
P3PL    equ     $c00f
TRIG0   equ     $c010
TRIG1   equ     $c011
TRIG2   equ     $c012
COLPM0  equ     $c012
TRIG3   equ     $c013
COLPM1  equ     $c013           
COLPM2  equ     $c014           
COLPM3  equ     $c015           
COLPF0  equ     $c016          
COLPF1  equ     $c017          
COLPF2  equ     $c018          
COLPF3  equ     $c019
COLBK   equ     $c01a
PRIOR   equ     $c01b           
GRACTL  equ     $c01d
HITCLR  equ     $c01e
CONSOL  equ     $c01f

; ANTIC registers.
DMACTL  equ     $d400        
CHACTL  equ     $d401        
DLISTL  equ     $d402        
DLISTH  equ     $d403
HSCROL  equ     $d404
VSCROL  equ     $d405
PMBASE  equ     $d407        
CHBASE  equ     $d409        
WSYNC   equ     $d40a
VCOUNT  equ     $d40b
NMIEN   equ     $d40e

; POKEY registers.
AUDF1   equ     $e800
POT0    equ     $e800
AUDC1   equ     $e801
POT1    equ     $e801
AUDF2   equ     $e802
POT2    equ     $e802
AUDC2   equ     $e803
POT3    equ     $e803
AUDF3   equ     $e804
POT4    equ     $e804
AUDC3   equ     $e805
POT5    equ     $e805
AUDF4   equ     $e806
POT6    equ     $e806
AUDC4   equ     $e807
POT7    equ     $e807
AUDCTL  equ     $e808
ALLPOT  equ     $e808
RANDOM  equ     $e80a
POTGO   equ     $e80b
IRQEN   equ     $e80e
SKCTL   equ     $e80f
SKSTAT  equ     $e80f

; BIOS locations of note.
IRQINT  equ     $fc03
ENDINT  equ     $fcb2
VBIINT  equ     $fcb8
KBDINT  equ     $fd02

; COLOR VALUES:
; 0 grey
; 1 light orange
; 2 orange
; 3 red orange
; 4 pink
; 5 purple
; 6 purple blue
; 7 blue
; 8 blue
; 9 light blue
; A turquoise
; B blue green
; C green
; D yellow green
; E orange green
; F light orange

