; This file is part of Magical Fairy Force.

; Magical Fairy Force is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; Magical Fairy Force is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with Magical Fairy Force.  If not, see <http://www.gnu.org/licenses/>.

; Copyright 2020 Average Software.

; Single player fight schedule screen

start_schedule
    jsr     hide_all_sprites
    mwa     $994,$f0                ; Start address.
    ldy     #0                      ; Schedule index.
.matrix_image_loop
    cpy     schedule_progress       ; Skip defeated characters.
    bmi     .next_image
    tya                             ; Save the index.
    pha
    ldx     fight_schedule,y
    lda     matrix_images_low,x 
    sta     $fe
    lda     matrix_images_high,x
    sta     $ff
    lda     $f0
    sta     $fc
    lda     $f1
    sta     $fd
    jsr     draw_cell_background
    pla                             ; Retrieve the index.
    tay
.next_image
    cpy     #7
    beq     .matrix_images_done
    iny
    lda     $f0                     ; Update the target address.
    clc
    adc     #4
    sta     $f0
    bcc     .matrix_image_loop
    inc     $f1
    bcs     .matrix_image_loop      ; Always true.
.matrix_images_done
    lda     schedule_progress       ; Set up the player/missile stuff.
    tay
    asl                             ; Multiply by 16 to get the horizontal position.
    asl
    asl
    asl
    sta     $f2
    lda     fight_schedule,y
    sta     p1_character
    tay
    and     #3                      ; This will get the character's column.
    tax
    lda     player_matrix_data_low,y
    sta     $f0
    lda     player_matrix_data_high,y
    sta     $f1
    lda     player_matrix_image_low,y
    sta     $fc
    lda     player_matrix_image_high,y
    sta     $fd
    ldy     #0
.pm_pos_loop
    lda     ($f0),y                 ; Set up positions.
    beq     .no_adjustment          ; Don't adjust offscreen portions.
    sec                             ; Adjust from the matrix position.
    sbc     schedule_pm_adjustment,x
    clc
    adc     $f2                     ; Add position offset.
.no_adjustment
    sta     HPOSP0,y
    sta     p0_matrix_pos_low,y     ; Appease the interrupts.
    iny
    cpy     #8
    bne     .pm_pos_loop
    ldx     #0
.pm_color_loop                      ; Set up colors.
    lda     ($f0),y
    sta     sCOLPM0,x
    inx
    iny
    cpy     #12
    bne     .pm_color_loop
    mwa     $1378,$fe
.pm_image_loop
    ldy     #16
    jsr     copy_memory
    ldy     $ff
    cpy     #$17
    beq     schedule_loop
    inc     $ff
    lda     $fc
    clc
    adc     #16
    sta     $fc
    bcc     .pm_image_loop
    inc     $fd
    bcs     .pm_image_loop          ; Always true.

schedule_loop subroutine
    ldy     #180                    ; Three second pause.
    jsr     wait_for_y_frames
    ldy     p1_character
    jsr     select_player_1
    jmp     start_versus_screen


